package advanced_counter;
###########################################################################################################
#                 HTMLfixIT Statistical counter "advanced" version main lib file.                         #
# This module along with the files in the "library" package, provide all the extra features offered in    #
# The advanced counter. Note,just adding these files to the standard fixit counter will not work as there #
# are several changes to the fixit-counter.pl file to accomodate the extra functionality.                 #
#                 Copyright Frank Hauptle 2003 all rights reserved franki@htmlfixit.com                   #
###########################################################################################################
use Fcntl qw(:DEFAULT :flock);
################################
#
# usage: rollover($script_name, $stats_file, $sitename, $date, $start_date, $end_date, $total_counter_file);
sub rollover
{
my ($script_name, $stats_file, $sitename, $date, $total_counter_file, $archives_dir, $demo, $page_count_summary_file,
                                                       $voting, $age_diff_days, $days_till_archiving,  $overall_count) = @_;

unless ($demo == 1)
{
my $new_date_filename = $date;
   $new_date_filename =~ tr/[\,\:\ ]/_/;

             # Archive the stat file and start again.
        my $archive_name = $archives_dir.'/'.$new_date_filename.'.txt';
             # Rename the datafile and move it to its new location
        rename ("$stats_file","$archive_name") or htmlfixit::return_error("Can't move $stats_file Reason: $!", 'yes');
             # Recreate the datafile, empty except for the date.:
        open (FILE, ">$stats_file") or htmlfixit::return_error("Can't create $stats_file Reason: $!", 'yes');    
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock $stats_file Reason: $!", 'yes'); 
        close (FILE);
         
              # Archive the main counter file and likewise start again.
        my $counter_archive_name = $archives_dir.'/counter-'.$new_date_filename.'.txt';
        rename ("$total_counter_file","$counter_archive_name") or htmlfixit::return_error("Can't move $total_counter_file Reason: $!", 'yes');
             # Recreate the counter file, with counts all set to 0.:
        open (FILE, ">$total_counter_file") or htmlfixit::return_error("Can't create $total_counter_file Reason: $!", 'yes');        
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock $total_counter_file $!", 'yes');
        print FILE '0|0|0';
        close (FILE);  
        
              # Archive the main counter file and likewise start again.
        my $page_count_archive_name = $archives_dir.'/pagecount-'.$new_date_filename.'.txt';
        rename ("$page_count_summary_file","$page_count_archive_name") or htmlfixit::return_error("Can't move $page_count_summary_file Reason: $!", 'yes');
             # Recreate the counter file, with counts all set to 0.:
        open (FILE, ">$page_count_summary_file") or htmlfixit::return_error("Can't create $page_count_summary_file Reason: $!", 'yes');        
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock $page_count_summary_file $!", 'yes');
        close (FILE);          


 }

FixitCounter::display_stats($total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count);
 }

################################
#
# usage: display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date, 'displaymode');

sub display_search_summary
{
my ($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date, $display) = @_;

# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless $sitename;
$date         = 'date not available' unless $date;
$start_date   = 'date not available' unless $start_date;
$end_date     = 'date not available' unless $end_date;

require "./fixit-counter.pl";
my $admin_header = FixitCounter::output_admin_header($script_name, $sitename, $date, $start_date, $end_date);
my @stats = FixitCounter::read_stats($stats_file);
my $hitreferer = 'Not Detected';
my @referer_google;
my @referer_yahoo;
my @referer_msn;
my @referer_altavista;
my @referer_aol;

foreach my $hit (@stats)
{
        if ($hit ne '') 
        {
        my $referer;
        (undef, undef, undef, undef, undef, undef, $referer) = split(/\|/, $hit);
        push (@referer_google, lc($referer))    if (($referer =~ m|google\.|i) && ($referer !~ m|url\?|) && ($referer !~ m|news\.google|));        
        push (@referer_yahoo, lc($referer))     if $referer =~ m|yahoo\.|i;
        push (@referer_altavista, lc($referer)) if $referer =~ m|altavista\.|i;
        push (@referer_msn, lc($referer))       if $referer =~ m|msn\.|i;
        push (@referer_aol, lc($referer))       if $referer =~ m|aolsearch\.|i;
        }
        else
        {
        next; 
        }
}
my $allrefs   = @stats;
my $googlecnt = @referer_google;
my $yahoocnt  = @referer_yahoo;
my $altvcount = @referer_altavista;
my $msncnt    = @referer_msn;
my $aolcnt    = @referer_aol;
my $total_searches = ($googlecnt + $yahoocnt + $altvcount + $msncnt + $aolcnt);

use CGI qw(param);

print "Content-type: text/html\n\n";
undef @stats;

print <<ENDOFHEADER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'><strong><br /><a name='refs'>Summary of search engine terms leading to: "$sitename"</a></strong><br /></p>
   <div align='left'>
   <p style='margin:6px;'>
   Of a total $allrefs saved referers, $total_searches were searches from the main search engines.<br /> 
   The below statistics are based on the $total_searches searches.
   </p></div>
</div><br />
<div align='center'>
ENDOFHEADER

my $google_percentage = 0; 
my $yahoo_percentage  = 0;
my $altav_percentage  = 0; 
my $msn_percentage    = 0; 
my $aol_percentage    = 0;

my $google_width      = 1;
my $yahoo_width       = 1;
my $altvcount_width   = 1;
my $msncnt_width      = 1;
my $aolcnt_width      = 1;

my @colors = ('red', 'green', 'blue', 'yellow', 'purple');
unless ($total_searches == 0)
{
   $google_percentage = (($googlecnt / $total_searches) * 100);
   $google_percentage = sprintf("%.2f", $google_percentage);
   $google_width      = int((($googlecnt / $total_searches) * 495) +1);

   $yahoo_percentage  = (($yahoocnt / $total_searches) * 100);
   $yahoo_percentage  = sprintf("%.2f", $yahoo_percentage);
   $yahoo_width       = int((($yahoocnt / $total_searches) * 495) +1);

   $altav_percentage  = (($altvcount / $total_searches) * 100);
   $altav_percentage  = sprintf("%.2f", $altav_percentage);
   $altvcount_width   = int((($altvcount / $total_searches) * 495) +1);

   $msn_percentage    = (($msncnt / $total_searches) * 100);
   $msn_percentage    = sprintf("%.2f", $msn_percentage);
   $msncnt_width      = int((($msncnt / $total_searches) * 495)+1);

   $aol_percentage    = (($aolcnt / $total_searches) * 100);
   $aol_percentage    = sprintf("%.2f", $aol_percentage);
   $aolcnt_width      = int((($aolcnt / $total_searches) * 495)+1);
}


print '<div class=\'cont\' align=\'left\'>'."\n";
print '<p align=\'center\'><strong>Search engine usage percentages.</p>'."\n";

print '<div align="left" style="width:'.$google_width.'px; height:25px; background:'.$colors[0].';"></div>'."\n";
print 'Google hits: &nbsp;&nbsp;&nbsp;'.$googlecnt.' hits, &nbsp;&nbsp;'.$google_percentage.' %.<br />'."\n";
print <<ENDOFFORM;
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='stats.pl#terms' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='google' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Summary of Google terms used' value='View google terms' class='buttons' />
</form>
<br /><br />
ENDOFFORM

print '<div align="left" style="width:'.$yahoo_width .'px; height:25px; background:'.$colors[1].';"></div>'."\n";
print 'Yahoo hits:&nbsp;&nbsp;&nbsp;&nbsp; '.$yahoocnt.' hits, &nbsp;&nbsp;&nbsp; '.$yahoo_percentage.' %.<br />'."\n";
print <<ENDOFFORM;
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='stats.pl#terms' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='yahoo' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Summary of Yahoo terms used' value='View Yahoo terms' class='buttons' />
</form>
<br /><br />
ENDOFFORM

print '<div align="left" style="width:'.$altvcount_width.'px; height:25px; background:'.$colors[2].';"></div>'."\n";
print 'Altavista hits:&nbsp; '.$altvcount.' hits,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$altav_percentage.' %.<br />'."\n";
print <<ENDOFFORM;
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='stats.pl#terms' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='altav' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Summary of AltaVista terms used' value='View AltaVista terms' class='buttons' />
</form>
<br /><br />
ENDOFFORM

print '<div align="left" style="width:'.$msncnt_width.'px; height:25px; background:'.$colors[3].';"></div>'."\n";
print 'MSN hits:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$msncnt.' hits,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$msn_percentage.' %.<br />'."\n";
print <<ENDOFFORM;
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='stats.pl#terms' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='msn' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Summary of MSN terms used' value='View MSN terms' class='buttons' />
</form>
<br /><br />
<a name='terms'> </a>
ENDOFFORM

print '<div align="left" style="width:'.$aolcnt_width.'px; height:25px; background:'.$colors[4].';"></div>'."\n";
print 'AOL hits:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$aolcnt.' hits,&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; '.$aol_percentage.' %.<br />'."\n";
print <<ENDOFFORM;
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='stats.pl#terms' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='aol' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Summary of AOL terms used' value='View AOL terms' class='buttons' />
</form>
<br /><br />
ENDOFFORM
print '<br /></div><br />'."\n";

my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = $odd;

if ($display eq 'google')
{
print '<br /><div class=\'cont\' align=\'left\'>'."\n";
print '<br /><b>GOOGLE search terms:</b><br />'."\n";
my (%google_terms, $count);
        foreach my $ref(@referer_google)        
        {       
        my ($uri, $string) = split (/\?/, $ref);
          if ($string)
           {        
           my $qstring = new CGI($string);
           my $searchq = $qstring->param('q');
           #my $searchq = param('q');
           $searchq =~ s|<|&lt\;| if $searchq;
           $searchq =~ s|>|&gt\;| if $searchq;
           $searchq =~ s|\s+$|| if $searchq;
           $searchq =~ s|^\s+|| if $searchq;
           $searchq =~ s|\'|\&apos\;| if $searchq;
           $searchq =~ s|\'|\&quot\;| if $searchq;
           if ($searchq)
                   {
                   if ($google_terms{$searchq}){$google_terms{$searchq} += 1;}
                   else{$google_terms{$searchq} = 1;} 
                   }
           }
        }
       
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td><b>Count</b><a name="terms">&nbsp;</a></td><td><b>Term</b></td></tr><tr><td></td><td></td></tr>'."\n";



##########################################################################################
# Attempt to get the new previous/next code working on the search stats.
##########################################################################################
my $num_google_terms = keys(%google_terms);
my $display_number = 500;
$num_google_terms = $display_number unless $num_google_terms;
my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;
# check to make sure there are some first.
if ($query->param('current'))
   {
   $current    = $num_google_terms if $query->param('current') eq 'last';
   $current    = $display_number if $query->param('current') eq 'first'; 
   }
   $current    = $num_google_terms if $current > $num_google_terms;
   $current    = $display_number if $current < $display_number;

   $current     = $num_google_terms if $current > $num_google_terms ;
my $next        = $current + $display_number;
my $previous    = $current - $display_number;
my $last_block = 'no';
my $start = 1;

$script_name = $script_name . '#terms';


if ($num_google_terms > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'google', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_google_terms)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_google_terms / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'google', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_google_terms))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'google', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what would cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'google', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_google_terms) % $display_number);
   $start = ($current - $remainder);
   }

}

##########################################################################################
print '<td colspan="2" align="center">'.$url_string.'</td>';
print '<tr colspan=\'2\'>&nbsp;</tr>'."\n";
# Pass the first and last number of the block of hits you want to display.

foreach my $key (sort {$google_terms{$b} <=> $google_terms{$a} } keys %google_terms)
        {
        # bypass loop when $count doesn't indicate the required min number
        if (($count < $start) || ($count > $current))
          {
          $count +=1;
          next;
          }
        # calculate percentage and display html if the count is under the required end num.
        if ($count <= $current)  
            {
                $tr_color = $odd;
                my $percentage = (($google_terms{$key} /  $total_searches) * 100);
                $percentage = sprintf("%.2f", $percentage);

                my $link_name = $key;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;

                        if ($name_length > 200)
                        {
                        $shortened1 = substr($link_name, 0, 200);
                        $link_name = $shortened1;
                        }                
                        if ($name_length > 100)
                        {
                        $shortened1 = substr($link_name, 0, 100);
                        $shortened2 = substr($link_name, 100);
                        $link_name = $shortened1 .'<br />'.$shortened2;
                        }        
                print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td><a href=\'http://www.google.com.au/search?q=';
                print $key.'\' target=\'_blank\'>'.$link_name.'</a>&nbsp;&nbsp;</td></tr><tr><td>&nbsp;</td><td>Percentage: (';
                print $percentage.'%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Actual: '. $google_terms{$key}.'</td></tr>'."\n";
              }
        $count +=1;
        }
print '</table>'."\n";
}

elsif ($display eq 'yahoo')
{
my (%yahoo_terms, $count);
        print '<br /><div class=\'cont\' align=\'left\'>'."\n";
        print '<br /><br /><br /><b>YAHOO search terms:</b><br />'."\n";
        foreach my $ref(@referer_yahoo)
        {
        my ($uri, $string) = split (/\?/, $ref);
            if ($string)
            {
            my $qstring = new CGI($string);
            my $searchq = $qstring->param('p');
            $searchq =~ s|<|&lt\;| if $searchq;
            $searchq =~ s|>|&gt\;| if $searchq;
            $searchq =~ s|\s+$|| if $searchq;
            $searchq =~ s|^\s+|| if $searchq;   
            $searchq =~ s|\'|\&apos\;| if $searchq;
            $searchq =~ s|\'|\&quot\;| if $searchq;
            if ($searchq)
                   {
                   if ($yahoo_terms{$searchq}){$yahoo_terms{$searchq} += 1;}
                   else{$yahoo_terms{$searchq} = 1;} 
                   }
            }
        }
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td>&nbsp;&nbsp;<b>Count</b>&nbsp;</td><td><b>Term</b></td></tr><tr><td></td><td></td></tr>'."\n";

##########################################################################################
# Attempt to get the new previous/next code working on the search stats.
##########################################################################################
my $num_yahoo_terms = keys(%yahoo_terms);
my $display_number = 500;
$num_yahoo_terms = $display_number unless $num_yahoo_terms;
my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;
if ($query->param('current'))
   {
   $current    = $num_yahoo_terms if $query->param('current') eq 'last';
   $current    = $display_number if $query->param('current') eq 'first'; 
   }
   $current    = $num_yahoo_terms if $current > $num_yahoo_terms;
   $current    = $display_number if $current < $display_number;

   $current     = $num_yahoo_terms if $current > $num_yahoo_terms ;
my $next        = $current + $display_number;
my $previous    = $current - $display_number;
my $last_block = 'no';
my $start = 1;

$script_name = $script_name . '#terms';


if ($num_yahoo_terms > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'yahoo', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_yahoo_terms)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_yahoo_terms / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'yahoo', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_yahoo_terms))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'yahoo', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what woudl cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'yahoo', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_yahoo_terms) % $display_number);
   $start = ($current - $remainder);
   }

}


##########################################################################################
print '<td colspan="2" align="center">'.$url_string.'</td>';
print '<tr colspan=\'2\'>&nbsp;</tr>'."\n";
# Pass the first and last number of the block of hits you want to display.
foreach my $key (sort {$yahoo_terms{$b} <=> $yahoo_terms{$a} } keys %yahoo_terms)
        {
        # bypass loop when $count doesn't indicate the required min number
        if (($count < $start) || ($count > $current))
          {
          $count +=1;
          next;
          }        
        # calculate percentage and display html if the count is under the required end num.
        if ($count <= $current)  
            {        
                $tr_color = $odd;        
                my $percentage = (($yahoo_terms{$key} /  $total_searches) * 100);
                $percentage = sprintf("%.2f", $percentage);

                my $link_name = $key;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;

                        if ($name_length > 200)
                        {
                        $shortened1 = substr($link_name, 0, 200);
                        $link_name = $shortened1;
                        }                
                        if ($name_length > 100)
                        {
                        $shortened1 = substr($link_name, 0, 100);
                        $shortened2 = substr($link_name, 100);
                        $link_name = $shortened1 .'<br />'.$shortened2;    
                        }
                print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td><a href=\'http://search.yahoo.com/search?fr=fp-pull-web-t&p='.$key.'\' target=\'_blank\'>'.$link_name.'</a>&nbsp;&nbsp;</td></tr><tr><td>&nbsp;</td><td>Percentage('.$percentage.'%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Actual: '. $yahoo_terms{$key}.'</td></tr>'."\n";
             }
        $count +=1;
        }
print '</table>'."\n";        
}

elsif ($display eq 'altav')
{
my (%altav_terms, $count);
print '<br /><div class=\'cont\' align=\'left\'>'."\n";
print '<br /><br /><br /><b>ALTAVISTA search terms:</b><br />'."\n";
foreach my $ref(@referer_altavista)
        {
        my ($uri, $string) = split (/\?/, $ref);
        if ($string)
           {
           my $qstring = new CGI($string);
           my $searchq = $qstring->param('q');
           $searchq =~ s|<|&lt\;| if $searchq;
           $searchq =~ s|>|&gt\;| if $searchq;
           $searchq =~ s|\s+$|| if $searchq;
           $searchq =~ s|^\s+|| if $searchq;
           $searchq =~ s|\'|\&apos\;| if $searchq;
           $searchq =~ s|\'|\&quot\;| if $searchq;
           if ($searchq)
                   {
                   if ($altav_terms{$searchq}){$altav_terms{$searchq} += 1;}
                   else{$altav_terms{$searchq} = 1;} 
                   }
           }
        }
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td>&nbsp;&nbsp;<b>Count</b>&nbsp;</td><td><b>Term</b></td></tr><tr><td></td><td></td></tr>'."\n";

##########################################################################################
# Attempt to get the new previous/next code working on the search stats.
##########################################################################################
my $num_altav_terms = keys(%altav_terms);
my $display_number = 500;
$num_altav_terms = $display_number unless $num_altav_terms;

my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;
if ($query->param('current'))
   {
   $current    = $num_altav_terms if $query->param('current') eq 'last';
   $current    = $display_number if $query->param('current') eq 'first'; 
   }
   $current    = $num_altav_terms if $current > $num_altav_terms;
   $current    = $display_number if $current < $display_number;

   $current     = $num_altav_terms if $current > $num_altav_terms ;
my $next        = $current + $display_number;
my $previous    = $current - $display_number;
my $last_block = 'no';
my $start = 1;

$script_name = $script_name . '#terms';


if ($num_altav_terms > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'altav', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_altav_terms)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_altav_terms / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'altav', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_altav_terms))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'altav', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what woudl cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'altav', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_altav_terms) % $display_number);
   $start = ($current - $remainder);
   }

}


##########################################################################################
print '<td colspan="2" align="center">'.$url_string.'</td>';
print '<tr colspan=\'2\'>&nbsp;</tr>'."\n";
# Pass the first and last number of the block of hits you want to display.
foreach my $key (sort {$altav_terms{$b} <=> $altav_terms{$a} } keys %altav_terms)
        {
        # bypass loop when $count doesn't indicate the required min number
        if (($count < $start) || ($count > $current))
          {
          $count +=1;
          next;
          }        
        # calculate percentage and display html if the count is under the required end num.
        if ($count <= $current)  
                {    
                $tr_color = $odd;
                my $percentage = (($altav_terms{$key} /  $total_searches) * 100);
                $percentage = sprintf("%.2f", $percentage);

                my $link_name = $key;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;

                        if ($name_length > 200)
                        {
                        $shortened1 = substr($link_name, 0, 200);
                        $link_name = $shortened1;
                        }                
                        if ($name_length > 100)
                        {
                        $shortened1 = substr($link_name, 0, 100);
                        $shortened2 = substr($link_name, 100);
                        $link_name = $shortened1 .'<br />'.$shortened2;
                        }
                print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td><a href=\'http://www.altavista.com/web/results?q='.$key.'\' target=\'_blank\'>'.$link_name.'</a>&nbsp;&nbsp;</td></tr><tr><td>&nbsp;</td><td>Percentage: '.$percentage.'%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Actual: '. $altav_terms{$key}.'</td></tr>'."\n";
                }
        $count +=1;
        }
print '</table>'."\n";                
}

elsif ($display eq 'msn')
{
my (%msn_terms, $count);
print '<br /><div class=\'cont\' align=\'left\'>'."\n";
print '<br /><br /><br /><b>MSN search terms:</b><br />'."\n";
foreach my $ref(@referer_msn)
        {
        my ($uri, $string) = split (/\?/, $ref);
        if ($string)
           {
           my $qstring = new CGI($string);
           my $searchq = $qstring->param('q');
           $searchq =~ s|<|&lt\;| if $searchq;
           $searchq =~ s|>|&gt\;| if $searchq;
           $searchq =~ s|\s+$|| if $searchq;
           $searchq =~ s|^\s+|| if $searchq;
           $searchq =~ s|\'|\&apos\;| if $searchq;
           $searchq =~ s|\'|\&quot\;| if $searchq;           
           if ($searchq)
                   {
                   if ($msn_terms{$searchq}){$msn_terms{$searchq} += 1;}
                   else{$msn_terms{$searchq} = 1;} 
                   }
           }
        }
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";;
print '<tr><td>&nbsp;&nbsp;<b>Count</b>&nbsp;</td><td><b>Term</b></td></tr><tr><td></td><td></td></tr>'."\n";
##########################################################################################
# Attempt to get the new previous/next code working on the search stats.
##########################################################################################
my $num_msn_terms = keys(%msn_terms);
my $display_number = 500;
$num_msn_terms = $display_number unless $num_msn_terms;
my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;
if ($query->param('current'))
{
   $current    = $num_msn_terms if $query->param('current') eq 'last';
   $current    = $display_number if $query->param('current') eq 'first'; 
}
   $current    = $num_msn_terms if $current > $num_msn_terms;
   $current    = $display_number if $current < $display_number;

   $current     = $num_msn_terms if $current > $num_msn_terms ;
my $next        = $current + $display_number;
my $previous    = $current - $display_number;
my $last_block = 'no';
my $start = 1;

$script_name = $script_name . '#terms';


if ($num_msn_terms > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'msn', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_msn_terms)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_msn_terms / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'msn', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_msn_terms))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'msn', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what woudl cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'msn', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_msn_terms) % $display_number);
   $start = ($current - $remainder);
   }

}


##########################################################################################
print '<td colspan="2" align="center">'.$url_string.'</td>';
print '<tr colspan=\'2\'>&nbsp;</tr>'."\n";
# Pass the first and last number of the block of hits you want to display.

foreach my $key (sort {$msn_terms{$b} <=> $msn_terms{$a} } keys %msn_terms)
        {
        # bypass loop when $count doesn't indicate the required min number
        if (($count < $start) || ($count > $current))
          {
          $count +=1;
          next;
          }        
        # calculate percentage and display html if the count is under the required end num.
        if ($count <= $current)  
                {          
                $tr_color = $odd;        
                my $percentage = (($msn_terms{$key} /  $total_searches) * 100);
                $percentage = sprintf("%.2f", $percentage);

                my $link_name = $key;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;

                        if ($name_length > 200)
                        {
                        $shortened1 = substr($link_name, 0, 200);
                        $link_name = $shortened1;
                        }                
                        if ($name_length > 100)
                        {
                        $shortened1 = substr($link_name, 0, 100);
                        $shortened2 = substr($link_name, 100);
                        $link_name = $shortened1 .'<br />'.$shortened2;
                        }
                print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td><a href=\'http://search.msn.com/results.aspx?FORM=MSNH&q='.$key.'\' target=\'_blank\'>'.$link_name.'</a>&nbsp;&nbsp;</td></tr><tr><td>&nbsp;</td><td>Percentage: '.$percentage.'%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'. $msn_terms{$key}.'</td></tr>'."\n";
                }
        $count +=1;
        }
print '</table>'."\n";    
}

elsif ($display eq 'aol')
{
my (%aol_terms, $count);
print '<br /><div class=\'cont\' align=\'left\'>'."\n";
print '<br /><br /><br /><b>AOL search terms:</b><br />'."\n";
foreach my $ref(@referer_aol)
        {
        my ($uri, $string) = split (/\?/, $ref);
        if ($string)
           {
           my $qstring = new CGI($string);
           my $searchq = $qstring->param('query');
           $searchq =~ s|<|&lt\;| if $searchq;
           $searchq =~ s|>|&gt\;| if $searchq;
           $searchq =~ s|\s+$|| if $searchq;
           $searchq =~ s|^\s+|| if $searchq;
           $searchq =~ s|\'|\&apos\;| if $searchq;
           $searchq =~ s|\'|\&quot\;| if $searchq;
           
           if ($searchq)
                   {
                   if ($aol_terms{$searchq}){$aol_terms{$searchq} += 1;}
                   else{$aol_terms{$searchq} = 1;} 
                   }
           }
        }
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td>&nbsp;&nbsp;<b>Count</b>&nbsp;</td><td><b>Term</b></td></tr><tr><td></td><td></td></tr>'."\n";
##########################################################################################
# Attempt to get the new previous/next code working on the search stats.
##########################################################################################
my $num_aol_terms = keys(%aol_terms);
my $display_number = 500;
$num_aol_terms = $display_number unless $num_aol_terms;
my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;
if ($query->param('current'))
   {
   $current    = $num_aol_terms if $query->param('current') eq 'last';
   $current    = $display_number if $query->param('current') eq 'first'; 
   }
   $current    = $num_aol_terms if $current > $num_aol_terms;
   $current    = $display_number if $current < $display_number;

   $current     = $num_aol_terms if $current > $num_aol_terms ;
my $next        = $current + $display_number;
my $previous    = $current - $display_number;
my $last_block = 'no';
my $start = 1;

$script_name = $script_name . '#terms';


if ($num_aol_terms > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'aol', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_aol_terms)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_aol_terms / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'aol', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_aol_terms))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'aol', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what woudl cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'aol', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_aol_terms) % $display_number);
   $start = ($current - $remainder);
   }

}


##########################################################################################
print '<td colspan="2" align="center">'.$url_string.'</td>';
print '<tr colspan=\'2\'>&nbsp;</tr>'."\n";
# Pass the first and last number of the block of hits you want to display.

foreach my $key (sort {$aol_terms{$b} <=> $aol_terms{$a} } keys %aol_terms)
        {
        # bypass loop when $count doesn't indicate the required min number
        if (($count < $start) || ($count > $current))
          {
          $count +=1;
          next;
          }        
        # calculate percentage and display html if the count is under the required end num.
        if ($count <= $current)  
                {          
                $tr_color = $odd;
                my $percentage = (($aol_terms{$key} /  $total_searches) * 100);
                $percentage = sprintf("%.2f", $percentage);

                my $link_name = $key;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;

                        if ($name_length > 200)
                        {
                        $shortened1 = substr($link_name, 0, 200);
                        $link_name = $shortened1;
                        }                
                        if ($name_length > 100)
                        {
                        $shortened1 = substr($link_name, 0, 100);
                        $shortened2 = substr($link_name, 100);
                        $link_name = $shortened1 .'<br />'.$shortened2;
                        }
                print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td><a href=\'http://aolsearch.aol.com/aol/search?query='.$key.'\' target=\'_blank\'>'.$link_name.'</a>&nbsp;&nbsp;</td></tr><tr><td>&nbsp;</td><td>Percentage: '.$percentage.'%)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Actual: '. $aol_terms{$key}.'</td></tr>'."\n";
                }
        $count +=1;
        }
print '</table>'."\n";  
}

print <<ENDOFFOOTER;
</div></div><br />
</div>
<br /><br />
<p align='center'>Copyright &copy; 2003 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFFOOTER
}

################################
#
# usage: display_country($script_name, $stats_file, $sitename, $date, $start_date, $end_date, 'displaytype');

sub display_country
{
my ($script_name, $stats_file, $sitename, $date, $start_date, $end_date, $display) = @_;

# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless $sitename;
$date         = 'date not available' unless $date;
$start_date   = 'date not available' unless $start_date;
$end_date     = 'date not available' unless $end_date;

require './library/Geography_Countries.pl';
require './library/IP_Country_Fast.pl';

require "./fixit-counter.pl";
my $admin_header = FixitCounter::output_admin_header($script_name, $sitename, $date, $start_date, $end_date);
my @stats = FixitCounter::read_stats($stats_file);
my $ip;
my %countrycounts;
my $reg = IP_Country_Fast->new();
my $message = '&nbsp;';
my $ip_match = 0;
foreach my $line (@stats)
{
        chomp $line;
        if ($line ne '') 
        {
        (undef, undef, undef, $ip, undef, undef, undef) = split(/\|/, $line);
        my $ip_result     = $reg->inet_atocc($ip);
        $ip_result  = 'na' unless $ip_result;
        $hitcount +=1;  
        if (($ip_result eq 'na') || ($ip_result eq '**') || ($ip_result eq ''))
        {next;}
        else {$ip_match++}
        $ip_result = 'GB' if $ip_result eq 'UK';
        my $country = Geography_Countries::country $ip_result;
        # Some fixes to make things more easily understood and less politically turbulant.
        $country = 'Asia Pacific (non specific)' if $ip_result eq 'AP';
        $country = 'Czechoslovakia (former)' if $ip_result eq 'CS';
        $country = 'European Union (non-specific)' if $ip_result eq 'EU';
        $country = 'Palestinian Territory' if $ip_result eq 'PS';
        $country = 'Hong Kong' if $ip_result eq 'HK';
        $country = 'Taiwan' if $ip_result eq 'TW';
        $country = $ip_result unless $country;
        
        if ($countrycounts{$country}){$countrycounts{$country} += 1;}
        else{$countrycounts{$country} = 1;} 
        }
        else
        {
        next;
        }
}

my $count = 1;
my %graphcount;
   # Generate the top 5
foreach my $key (reverse sort {$countrycounts{$a} <=> $countrycounts{$b} } keys %countrycounts)
        {
        $graphcount{$key} = $countrycounts{$key} if $count < 6;
        $count +=1;
        }
   # Print the top 5 graph.
my @colors = ('red', 'green', 'blue', 'yellow', 'purple');
my ($total_top_five, $dishits);
foreach my $key (keys %graphcount)
        {
        $total_top_five += $graphcount{$key};
        }
  if ($display eq 'topfive')
   {
   if ($hitcount)
	   {
	   $dishits = $hitcount;
	   }
   else
	   {
	   $dishits = 'no';
	   $message = '<b>Top 5 countries that visit '.$sitename.'.</b><br /> The top 5 countries constitute '.$total_top_five.' of a total '.$dishits.' hits.';
	   } 
   }
else 
   {
   if ($hitcount)
	   {
	   $dishits = $hitcount;
	   }
   else
	   {
	   $dishits = 'no';
	   }
   $message = '<b>Detailed summary of countries that visit '. $sitename.'.</b><br />Based on a total of '.$dishits.' hits.';
   }      

print "Content-type: text/html\n\n";
print <<ENDOFHEADER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'>$message<br /></p>
</div><br /><div align='left' class='cont'><br />
ENDOFHEADER

if ($display eq 'topfive')
{   
my $colorcount ='0';        
foreach my $key (reverse sort {$graphcount{$a} <=> $graphcount{$b} } keys %graphcount)
    {
    my $width = int((($graphcount{$key} /  $hitcount) * 496));
    my $percentage = (($graphcount{$key} /  $hitcount) * 100);
       $percentage = sprintf("%.2f", $percentage);
         print '<div align="left" style="width:'.$width.'px; height:25px; background:'.$colors[$colorcount].';"></div>'."\n";
         print $key .': '.$graphcount{$key}.' hits:&nbsp;&nbsp;&nbsp;'.$percentage.'%<br /><br />'."\n";
    $colorcount +=1;
    }
print <<BUTTON;
<br /><br />
<div align='center'>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='country_detail' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show detailed summary of the countries hitting your site.' value='Detailed country summary' class='buttons' />
</form><br />    
</div>
BUTTON
} # end: if ($display eq 'topfive')
 
unless ($display eq 'topfive')
{
my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = $odd;
$count =1;
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td>&nbsp;<b>Count</b>&nbsp;</td><td><b>Country</b>&nbsp;&nbsp;</td><td><b>Percentage</b></td><td><b>Hits</b></td></tr>'."\n";
print '<tr colspan=\'4\'>&nbsp;</tr>'."\n";

foreach my $key (reverse sort {$countrycounts{$a} <=> $countrycounts{$b} } keys %countrycounts)
        {
        if ($count > 1){ $tr_color = ($count % 2) ? $odd : $evn;}
        my $percentage = (($countrycounts{$key} /  $hitcount) * 100);
        $percentage = sprintf("%.2f", $percentage);
        print $tr_color.'<td>&nbsp;'.$count.'&nbsp;</td><td>'.$key.'&nbsp;&nbsp;</td><td>('.$percentage.'%)</td><td>'. $countrycounts{$key}.'</td></tr>'."\n";
        $graphcount{$key} = $countrycounts{$key} if $count < 6;
        $count +=1;
        }
  # Work out how many IP's were not resolved to a country.       
my $total_ips = scalar(@stats);
my $total_resolved_countries = $total_ips - $ip_match; 
print $tr_color.'<td>&nbsp;&nbsp;</td><td><strong>Number of unresolvable IPs:</strong>&nbsp;&nbsp;</td><td></td><td>'.$total_resolved_countries.'</td></tr>'."\n";     
print '</table>'."\n";
}
print <<ENDOFFOOTER;
</div><br /></div>
<br /><br />
<p align='center'>Copyright &copy; 2003 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFFOOTER
}

################################
#
# usage: pagesummary($script_name, $page_count_summary_file, $sitename, $date, $start_date, $end_date, 'displaytype');
sub pagesummary
{
my ($script_name, $page_count_summary_file, $sitename, $date, $start_date, $end_date, $display) = @_;

my $lop_www = 'yes';
# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless $sitename;
$date         = 'date not available' unless $date;
$start_date   = 'date not available' unless $start_date;
$end_date     = 'date not available' unless $end_date;
my @colors = ('red', 'green', 'blue', 'yellow', 'purple');

my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = $odd;

require "./fixit-counter.pl";
my $admin_header = FixitCounter::output_admin_header($script_name, $sitename, $date, $start_date, $end_date, $display);
my %pages_hit;
my $all_pages;

print "Content-type: text/html\n\n";
print <<ENDOFHEADER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'><b><br />Pages hit summary for $sitename</b><br /><br /></p>
</div><br /><div align='left' class='cont'><br />
ENDOFHEADER

    open (PAGES, "$page_count_summary_file") or htmlfixit::return_error("Can't open $page_count_summary_file Reason: $!", 'yes');
    flock(PAGES,LOCK_SH) or htmlfixit::return_error("Can't lock $page_count_summary_file Reason: $!", 'yes');
    while(<PAGES>)
    {
    my ($stamp, $pagedate, $location) = split(/\|/ ,$_);
    $all_pages += 1;
        if ($location)
           {
           chomp $location;
           $location =~ s|http\://www\.|http\://| if $lop_www eq 'yes';
           if ($pages_hit{$location}){$pages_hit{$location} += 1;}
           else{$pages_hit{$location} = 1;} 
           }
    }
    close (PAGES);
 
if ($display eq 'topfive')
{   
print '<b>Display of the five most popular entry pages to: '.$sitename.'.</b><br /><br />'."\n";
my $colorcount ='0';        
foreach my $key (reverse sort {$pages_hit{$a} <=> $pages_hit{$b} } keys %pages_hit)
    {
	       # Don't calculate or print if there are already 5 up.
    if ($colorcount < 5)
    {
    my $width = int((($pages_hit{$key} /  $all_pages) * 496));
    my $percentage = (($pages_hit{$key} /  $all_pages) * 100);
       $percentage = sprintf("%.2f", $percentage);
         print '<div align="left" style="width:'.$width.'px; height:25px; background:'.$colors[$colorcount].';"></div>'."\n";
         print '<a href=\''. $key .'\'>'.$key.'</a><br />'.$pages_hit{$key}.' hits:&nbsp;&nbsp;&nbsp;'.$percentage.'%<br /><br />'."\n";
    }
    $colorcount +=1;
    }
print <<BUTTON;
<br /><br />
<div align='center'>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='pages_hit_detail' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show detailed summary of the page hits.' value='Detailed page hit summary' class='buttons' />
</form><br />    
</div>
BUTTON
} # end: if ($display eq 'topfive') 
 
unless ($display eq 'topfive')
{  
my $count =1;
print '<b>Detailed display of page counts for: '.$sitename.'.</b><br /><br />'."\n";
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td><b>Count</b></td><td colspan=\'3\'><b>Page</b></td></tr>'."\n";
print '<tr colspan=\'2\'></tr>'."\n";

foreach my $key (reverse sort {$pages_hit{$a} <=> $pages_hit{$b} } keys %pages_hit)
       {
        my $percentage = (($pages_hit{$key} /  $all_pages) * 100);
        $percentage = sprintf("%.2f", $percentage);
		# My own removal of basic unsafe characters in url strings to block XSS.
           $key =~ s/</&lt;/g;
           $key =~ s/>/&gt;/g;
		   $key =~ s/"/%22/g;
		   $key =~ s/'/&#39;/g;		   

		   
require './library/Entities.pl';
$key = Entities::encode($key);


        my $link_name = $key;
        my $name_length = length $link_name;
        my $shortened1;
        my $shortened2;
        my $was_shortened = 1;
        my $continued ='';
        
                if ($name_length > 180)
                {
                $shortened1 = substr($link_name, 0, 180);
                $link_name = $shortened1;
                $was_shortened = 2;
                }                
                if ($name_length > 100)
                {
                $shortened1 = substr($link_name, 0, 98);
                $shortened2 = substr($link_name, 98);
                $link_name = $shortened1 .'<br />'.$shortened2;
                }           
                $continued = ' ~' if $was_shortened ==2;
        
        print $tr_color.'<td>'.$count.'</td><td colspan=\'3\'><a href=\''.$key.'\'>'.$link_name.$continued.'</a></td></tr><tr><td>&nbsp;</td>'."\n";
        print '<td>Hits: '.$pages_hit{$key}.'</td><td>Percent: ('. $percentage.'%)</td><td>&nbsp;</td></tr>'."\n";
        $count +=1;
        }
print '</table><br />'."\n"; 
}

print <<ENDOFFOOTER;
</div><br /></div>
<br /><br />
<p align='center'>Copyright &copy; 2003 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFFOOTER
}



################################
#
# usage: display_daily_hit_summary($script_name, $stats_file, $sitename, $date, $start_date, $end_date, 'displaymode');;
sub display_daily_hit_summary
{
my ($script_name, $stats_file, $sitename, $date, $start_date, $end_date, $display) = @_;
   
# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless $sitename;
$date         = 'date not available' unless $date;
$start_date   = 'date not available' unless $start_date;
$end_date     = 'date not available' unless $end_date;

my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = $odd;
my %day_hits;

# Saturday, November 1, 2003 at 02:37 AM
my @stats = FixitCounter::read_stats($stats_file);
my $num_stats = @stats;
foreach my $stat (@stats)
{
my $hitdate;
(undef, $hitdate, undef, undef, undef, undef, undef) = split(/\|/, $stat);
my $month_day;
(undef, $month_day, undef)= split(/\,/, $hitdate);
$month_day =~ s|^\s+||;
if ($day_hits{$month_day}){$day_hits{$month_day} += 1;}
else{$day_hits{$month_day} = 1;} 
}

require "./fixit-counter.pl";
my $admin_header = FixitCounter::output_admin_header($script_name, $sitename, $date, $start_date, $end_date);

print "Content-type: text/html\n\n";
print <<ENDOFHEADER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'><strong><br /><a name='refs'>Daily summary of hits to: "$sitename"</a></strong><br /></p>
   <div align='left'>
   <p style='margin:6px;'>
   
   
   </p></div>
</div><br />
<div align='center'>
ENDOFHEADER

my $count = 1;
my %graphcount;
   # Generate the top 5
foreach my $key (reverse sort {$day_hits{$a} <=> $day_hits{$b} } keys %day_hits)
        {
        $graphcount{$key} = $day_hits{$key} if $count < 6;
        $count +=1;
        }
   # Print the top 5 graph.
my @colors = ('red', 'green', 'blue', 'yellow', 'purple');
my $total_top_five;
foreach my $key (keys %graphcount)
        {
        $total_top_five += $graphcount{$key};
        }

if ($display eq 'topfive')
{   
print '<div align=\'left\' class=\'cont\'><br />'."\n";
print '<p><b>Top five days for hits to: '.$sitename.'.</b></p>'."\n";
my $colorcount ='0';        
foreach my $key (reverse sort {$graphcount{$a} <=> $graphcount{$b} } keys %graphcount)
    {
    my $width = int((($graphcount{$key} /  $num_stats) * 496));
    my $percentage = (($graphcount{$key} /  $num_stats) * 100);
       $percentage = sprintf("%.2f", $percentage);
         print '<div align="left" style="width:'.$width.'px; height:25px; background:'.$colors[$colorcount].';"></div>'."\n";
         print $key .': '.$graphcount{$key}.' hits:&nbsp;&nbsp;&nbsp;'.$percentage.'%<br /><br />'."\n";
    $colorcount +=1;
    }
print '</div>'."\n";
print <<BUTTON;
<br /><br />
<div align='center'>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='dayhit_detail' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show detailed summary of hits for each day in the stats file.' value='Detailed daily hits summary' class='buttons' />
</form><br />    
</div>
BUTTON
}

unless ($display eq 'topfive')
{  
print '<div align=\'left\' class=\'cont\'><br />'."\n";
my $count =1;
print '<b>Detailed display of daily hit counts for: '.$sitename.'.</b><br /><br />'."\n";
print '<table border="0" width="100%" class="cont" cellpadding="3" cellspacing="0">'."\n";
print '<tr><td><b>Count</b></td><td><b>Date</b></td><td><b>Percentage</b></td><td><b>Hits</b></td></tr>'."\n";
print '<tr colspan=\'4\'>&nbsp;</tr>'."\n";

# Change the month/day to numeric format, sort the hash based on that, then change back to alphanumeric format and display.
my %numeric_count;
my @months = ('January','February','March','April','May','June','July',
              'August','September','October','November','December');
my %months_num = ('January'   => '01',
                  'February'  => '02',
                  'March'     => '03',
                  'April'     => '04',
                  'May'       => '05',
                  'June'      => '06',
                  'July'      => '07',
                  'August'    => '08',
                  'September' => '09',
                  'October'   => '10',
                  'November'  => '11',
                  'December'  => '12');

   # We need to do some creative date manipulation to make sure the 
   # dates sort correctly, not alphabetically.
foreach my $key (keys %day_hits)
       {
       # Split the 'month day" into seperate values.
       my ($month, $day) = split(/ / , $key);
       # Then change the month to numeric.
       $month = $months_num{$month};
       # Put both the day and month into double digit format.
       $day = sprintf("%.2d", $day);
       #Put the day after the numeric month.
       my $numeric_date = $month.'/'.$day;
       # Now push that into the new array.
       $numeric_count{$numeric_date} = $day_hits{$key};
       }
      
foreach my $key (sort keys %numeric_count)
       {
        if ($count > 1){ $tr_color = ($count % 2) ? $odd : $evn;}
        my $percentage = (($numeric_count{$key} /  $num_stats) * 100);
        $percentage = sprintf("%.2f", $percentage);
        my ($mon, $day) = split(/\//, $key);
        $mon = ($mon -1);
        $mon = $months[$mon];
        my $date = $mon.' '.$day;        
        print $tr_color.'<td>'.$count.'</td><td>&nbsp;&nbsp;'.$date.'</td><td>('.$percentage.'%)</td><td>'. $numeric_count{$key}.'</td></tr>'."\n";
        $count +=1;
        }
print '</table><br />'."\n"; 
print '</div>'."\n";
}

print <<ENDOFFOOTER;
</div><br /></div>
<br /><br />
<p align='center'>Copyright &copy; 2003 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFFOOTER

}
#open (FILE, ">$used_ips_dir/$new_filename") or htmlfixit::return_error("Can't open $used_ips_dir/$new_filename Reason: $!", 'yes');

################################
#
# usage: write_pages_hit($query, $timestamp, $page_count_summary_file, $date);
sub write_pages_hit
{
my ($query, $timestamp, $page_count_summary_file, $date) = @_;

#######################################################
my $ip_ignore;
(undef, undef, undef, undef, undef, undef, undef, undef, undef, $ip_ignore, undef, undef, undef, undef, undef, 
undef, undef, undef) = counter_config::config();
 my $ip_address =  $ENV{'REMOTE_ADDR'};
    chomp $ip_address;
 my $match = 0;
# Open IP To look for a match
open (IP, "$ip_ignore") or  htmlfixit::return_error("Can't open $ip_ignore Reason: $!", 'yes');
flock(IP,LOCK_SH) or htmlfixit::return_error("Can't lock $ip_ignore Reason: $!", 'yes');
my @IP_array = <IP>;
close (IP);
   foreach $ip (@IP_array)
   {   
    chomp $ip;
         if($ip eq $ip_address)
           {
           $match += 1;
           }
   } #end of foreach
#######################################################

if ($match == 0)
{
     if ($query->param('loc'))
        {
        $page = $query->param('loc');
           $page =~ s/</&lt;/g;
           $page =~ s/>/&gt;/g;
#		   $page =~ s/"/%22/g;
		   $page =~ s/\|/%7C/g;	
		   
require './library/Entities.pl';
$page = Entities::encode($page);
                if ($page)
                {
                my $total_collected_data = $timestamp.'|'.$date.'|'.$page."\n";
                     open (STATS, ">>$page_count_summary_file") or  htmlfixit::return_error("Can't open $page_count_summary_file Reason: $!", 'yes');
                     flock(STATS,LOCK_EX)   or htmlfixit::return_error("Can't lock $page_count_summary_file Reason: $!", 'yes');
                     print STATS "$total_collected_data";
                     close (STATS);
                }
        } # End if ($query->param('loc'))
} # End if ($match == 0)  
}
1;