package FixitCounter; 
# newest on 14th June 2008
######################## Inportant note. ###########################
# If running this script on a Unix machine, it is recommended that #
# a -T be placed after the path to perl on the first line. like so:#
# #!/usr/bin/perl -T                                               #
# This will put the script into "Taint" mode, which is a very good #
# practice for cgi-scripts. Windows users should ask their system  #
# Administrator for the file extension required or Taint mode perl.#
####################################################################
####################################################################
#                   HTMLfixIT Statistical counter.                 #
#                       http://htmlfixit.com                       #
#                       Copyright Frank Hauptle.                   #
#                         All rights reserved.                     # 
#                            Version 2.00 pro                      #
#                        RC2, 14 June 2008                         #
#         Please report any bugs to franki@htmlfixit.com           #
####################################################################
####################################################################
#                      THE USUAL DISCLAIMER.                       # 
# This software is provided by the copyright holders and           #
# contributors `as is' and any express or implied warranties,      # 
# including, but not limited to, the implied warranties of         #
# merchantability and fitness for a particular purpose are         #
# disclaimed.                                                      #
# In no event shall the author or contributors be liable for any   #
# direct, indirect, incidental, special, exemplary,or consequential# 
# damages (including, but not limited to, procurement of substitute#
# goods or services; loss of use, data, or profits; or business    #
# interruption) however caused and on any theory of liability,     #
# whether in contract, strict liability, or tort (including        #
# negligence or otherwise)  arising in any way out of the use of   #
# this software, even if advised of the possibility of such damage.#
#                                                                  #
#                                                                  #  
####################################################################

sub run {
####################################################################
#                    Configuration Settings.                       #
####################################################################
       # All config for this script is in the seperate counter_config.pl
       # file, for unix hosts, no modifications are necessary here.
       # For windows hosts, the two variables below should be changed
       # to the directory path that the script will reside in on the server.
       # for example: $path_to_lib = 'c:/Inetpub/Scripts/downloads';
       # DO NOT add a trailing / to the end.
       # Mod_perl users will likewise need to set the full paths.
       #############################################################

# IF YOUR SCRIPT IS WORKING PERFECTLY, YOU CAN SET $run_tests to 'no' TO SPEED THINGS UP A LITTLE.
my $run_tests = 'yes';


my $path_to_lib    = '.';  
my $path_to_config = '.';

if ($run_tests eq 'yes')
{
###################################################################
# Test to ensure required library and config files can be found.
my ($hashtmlfixitlib, $hascounterconfig, $hasadvcounter, $hasadvcounterconfig);
eval "require \"$path_to_lib/htmlfixit-lib.pl\""; $hashtmlfixitlib = $@ ? 0 : 1;
eval "require \"$path_to_config/counter_config.pl\""; $hascounterconfig = $@ ? 0 : 1;
eval "require \"$path_to_lib/advanced_counter.pl\""; $hasadvcounter = $@ ? 0 : 1;
eval "require \"$path_to_lib/advanced_counter_config.pl\""; $hasadvcounterconfig = $@ ? 0 : 1;

unless ($hashtmlfixitlib)
{
#Do the printing manually since we can't use the error routine since it is located in the missing library..
print "Content-type: text/html\n\n";
print "Cannot locate the file: htmlfixit-lib.pl, Check your paths as this file should be in the same directory as this script file";
exit;
}
# The others we can just use the default error routine as we have the required library file.
unless ($hascounterconfig){htmlfixit::return_error("Can't locate file: counter_config.pl. Check your paths as this file should be in the same directory as this script file.", 'yes');}
unless ($hasadvcounter){htmlfixit::return_error("Can't locate file: advanced_counter.pl. Check your paths as this file should be in the same directory as this script file.", 'yes');}
unless ($hasadvcounterconfig){htmlfixit::return_error("Can't locate file: advanced_counter_config.pl. Check your paths as this file should be in the same directory as this script file.", 'yes');}
}
require "$path_to_lib/htmlfixit-lib.pl";
require "$path_to_config/counter_config.pl";

require "$path_to_lib/advanced_counter.pl";
require "$path_to_lib/advanced_counter_config.pl";

use CGI qw(:standard);
use CGI::Cookie;
use Fcntl qw(:DEFAULT :flock);
      # Some security stuff.
$CGI::DISABLE_UPLOADS = 1;
$CGI::POST_MAX        = 512 * 1024;

my $query = new CGI;
# If $demo is 1, then assume demo mode, 
# if $demo is 0, assume normal operation.
my $demo              = 0;

       # Get the configuration values.
my ($user_name, $pass_word, $sitename, $output_image_path, $days_before_archiving_stats, $archives_dir,
        $stats_file, $total_counter_file, $overall_count, $ip_ignore, $used_ips_dir, $script_name, $ip_age, $domain, $path, 
        $expiration, $cookie_id, $tmp_dir) = counter_config::config();

my ($library_path, $page_count_summary_file) = advanced_counter_config::adconfig();


# Put some tests here to ensure that the files exist and can be written to.
if ($run_tests eq 'yes')
{
# STANDARD COUNTER TESTS.
unless (-e $output_image_path)
{htmlfixit::return_error("Can't locate file: $output_image_path. Check in the counter_config.pl file for the path set in \$output_image_path", 'yes');}
unless (-r $output_image_path) { htmlfixit::return_error("Can't read from file: $output_image_path. Check your permissions for this file.", 'yes');}

unless (-e $archives_dir)
{htmlfixit::return_error("Can't locate directory: $archives_dir. Check in the counter_config.pl file for the path set in \$archives_dir", 'yes');}
unless (-w $archives_dir) { htmlfixit::return_error("Can't write to directory: $archives_dir. Check your permissions for this directory.", 'yes');}

unless (-e $stats_file)
{htmlfixit::return_error("Can't locate file: $stats_file. Check in the counter_config.pl file for the path set in \$stats_file", 'yes');}
unless (-w $stats_file) { htmlfixit::return_error("Can't write to file: $stats_file. Check your permissions for this file.", 'yes');}

unless (-e $total_counter_file)
{htmlfixit::return_error("Can't locate file: $total_counter_file. Check in the counter_config.pl file for the path set in \$total_counter_file", 'yes');}
unless (-w $total_counter_file) { htmlfixit::return_error("Can't write to file: $total_counter_file. Check your permissions for this file.", 'yes');}

unless (-e $overall_count)
{htmlfixit::return_error("Can't locate file: $overall_count. Check in the counter_config.pl file for the path set in \$overall_count", 'yes');}
unless (-w $overall_count) { htmlfixit::return_error("Can't write to file: $overall_count. Check your permissions for this file.", 'yes');}

unless (-e $ip_ignore)
{htmlfixit::return_error("Can't locate file: $ip_ignore. Check in the counter_config.pl file for the path set in \$ip_ignore", 'yes');}
unless (-r $ip_ignore) { htmlfixit::return_error("Can't read from file: $ip_ignore. Check your permissions for this file.", 'yes');}

unless (-e $used_ips_dir)
{htmlfixit::return_error("Can't locate directory: $used_ips_dir. Check in the counter_config.pl file for the path set in \$used_ips_dir", 'yes');}
unless (-w $used_ips_dir) { htmlfixit::return_error("Can't write to directory: $used_ips_dir. Check your permissions for this directory.", 'yes');}

unless (-e $tmp_dir)
{htmlfixit::return_error("Can't locate directory: $tmp_dir. Check in the counter_config.pl file for the path set in \$tmp_dir", 'yes');}
unless (-w $tmp_dir) { htmlfixit::return_error("Can't write to directory: $tmp_dir. Check your permissions for this directory.", 'yes');}


if ($domain =~ m|http://|){htmlfixit::return_error('The $domain setting in counter_config.pl should contain only your full domain name, without the http://', 'yes');}
if ($path =~ m|http://|){htmlfixit::return_error('The $path setting in counter_config.pl should not contain your domain name, it is just the Web address of the script directory without the domain name', 'yes');}
if ($path !~ m|^\/cgi\-bin|){htmlfixit::return_error('The $path setting in counter_config.pl should usually begin with /cgi-bin and point to the directory containing this script. If you do not have a specific cgi-bin directory then just open the fixit-counter.pl file and set $run_tests to \'no\'<br /><br />', 'no');}


# ADVANCED COUNTER TESTS.
unless (-e $library_path)
{htmlfixit::return_error("Can't locate directory: $library_path. Check in the advanced_counter_config.pl file for the path set in \$library_path", 'yes');}
unless (-r $library_path) { htmlfixit::return_error("Can't read from directory: $library_path. Check your permissions for this directory.", 'yes');}

unless (-e $page_count_summary_file)
{htmlfixit::return_error("Can't locate file: $page_count_summary_file. Check in the advanced_counter_config.pl file for the path set in \$page_count_summary_file", 'yes');}
unless (-w $page_count_summary_file) { htmlfixit::return_error("Can't write to file: $page_count_summary_file. Check your permissions for this file.", 'yes');}

} # End of tests.


######################### END OF TESTS#################################
my $date = htmlfixit::get_date();
my $timestamp = time;

# Referrer in perl is no good for this script as it will
# So instead we get the referrer via javascript and pass it to this script.
require './library/Entities.pl';

my ($referer, $screen_res);
if ($query->param('ref'))
   {
   $referer = $query->param('ref');  
   $referer = Entities::encode($referer);
   }
else{$referer = 'No referer or unundetectable';}

if ($query->param('res'))
   {
   $screen_res = $query->param('res');  
   }
else{$screen_res = 'Not detectable';}

# DO NOT CHANGE THIS SETTING, IT IS NOT EFFECTIVE IN THIS VERSION YET.
my $ignore_certain_ips = 'yes'; # Yes or no. (just yes at present)
       # If the above is yes, then the below file will store
       # IP addresses that you want the counter to ignore.
       # Put your own IP in there. (one IP per line.)

       # We have to open the stats file and make sure the oldest entry
       # is not over the set time period and if it is, archive it and
       # start a new one.
my $first_stat = read__first_stat($stats_file);
$first_stat = '||||||' unless $first_stat; 
my @first_line = split(/\|/, $first_stat);

my $voting = 0;       
       # Grab the first timestamp from the stats file.
my $first_hit_date = $first_line[2];
   $first_hit_date = $timestamp unless $first_hit_date;
       # Subtract the first hit date from the current date.
my $age_diff_seconds = ($timestamp - $first_hit_date );

       # Work it out in days and round it down to an integer.
   $age_diff_seconds = 86400 unless $age_diff_seconds;
my $age_diff_days = int(((($age_diff_seconds / 60) / 60) / 24));
       
       # How long till the next archiving?
my $days_till_archiving;
       if ($age_diff_days > $days_before_archiving_stats)
          {$days_till_archiving = 0;}
       else   
       {$days_till_archiving = $days_before_archiving_stats - $age_diff_days;}

my $new_date_filename = $date;
   $new_date_filename =~ tr/[\,\:\ ]/_/;

my $archive_timestamp = $new_date_filename;

unless ($first_hit_date == 0)
{
if ($age_diff_days > $days_before_archiving_stats) 
        {
             # Archive the stat file and start again.
        my $archive_name = $archives_dir . '/' .$new_date_filename . '.txt';
             # Rename the datafile and move it to its new location
        rename ("$stats_file","$archive_name") or die htmlfixit::return_error("Can't move file $stats_file $!", 'yes');
        
        # Recreate the datafile, empty except for the date.:
        open (FILE, ">$stats_file") or htmlfixit::return_error("Can't open file $stats_file $!", 'yes');
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock file $stats_file $!", 'yes');
        close (FILE);
        $age_diff_days = 0;
         
              # Archive the main counter file and likewise start again.
        my $counter_archive_name = $archives_dir . '/counter-' .$new_date_filename . '.txt';
        rename ("$total_counter_file","$counter_archive_name") or htmlfixit::return_error("Can't move file $total_counter_file $!", 'yes');
        # Recreate the counter file, with counts all set to 0.:
        open (FILE, ">$total_counter_file") or htmlfixit::return_error("Can't open file $total_counter_file $!", 'yes');
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock file $total_counter_file $!", 'yes');
        print FILE '0|0|0';
        close (FILE);        

              # Archive the pagecount file and likewise start again.
        my $page_count_archive_name = $archives_dir.'/pagecount-'.$new_date_filename.'.txt';
        rename ("$page_count_summary_file","$page_count_archive_name") or htmlfixit::return_error("Can't move file $page_count_summary_file $!", 'yes');
           # Recreate the counter file.
        open (FILE, ">$page_count_summary_file") or htmlfixit::return_error("Can't create file $page_count_summary_file $!", 'yes');        
        flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock file $page_count_summary_file $!", 'yes');
        close (FILE);  
        }
}

# Get the login status.
my ($login_status, $login_message, $session) = htmlfixit::login_code($query, $cookie_id, 'username', 
                                                             'password', 'login',  
                                                             $user_name, $pass_word, 
                                                             'count', $tmp_dir,$domain, 
                                                             $path, $expiration);

if    ($login_status == 0){htmlfixit::not_specified_error('?count=yes&nojs=yes'); goto _end;}
# Use this to bypass the cookie if it is required.
#elsif ($query->param('login') eq 'yes'){what_to_do_admin($query, $total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, 
#                           $script_name, $overall_count, $archives_dir, $demo, $page_count_summary_file); goto _end;}
elsif ($login_status == 1){what_to_do_admin($query, $total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, 
                           $script_name, $overall_count, $archives_dir, $demo, $page_count_summary_file); goto _end;}
elsif ($login_status == 2){htmlfixit::display_login('Stats Counter', $script_name, 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}
elsif ($login_status == 3){htmlfixit::display_login('Stats Counter', $script_name, 'login=yes', $login_message,$demo,$user_name,$pass_word); goto _end;}

elsif ($login_status == 4){what_to_do_action($query, $date, $timestamp, $script_name, $page_count_summary_file); goto _end;}

else {goto _end;}
# Create a label to send script to end.
_end:
} # End of sub run.

#############################
sub what_to_do_action
        {
        my ($query, $date, $timestamp, $script_name, $page_count_summary_file) = @_;
        # This subs job is to determine what action task is to be performed and run the appropriate code.
                if ($query->param('nojs'))
                {
                # perform check for googlebot, non Js browsers here.
                &increment_count($query, $date, $timestamp, 'nojs');
                #advanced_counter::write_pages_hit($query, $timestamp, $page_count_summary_file, $date);
                }
                else
                {
                # Normal JS browser stats count.
                &increment_count($query, $date, $timestamp, 'js');
                advanced_counter::write_pages_hit($query, $timestamp, $page_count_summary_file, $date);
                }
         }

#############################
sub what_to_do_admin
  {
        # This subs job is to determine what admin task is to be performed and run the appropriate code.
        my ($query, $total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, 
        $overall_count, $archives_dir, $demo, $page_count_summary_file) = @_;
        my ($start_date, $end_date); 
        $start_date = $query->param('start_date') || 'no start date';
        $end_date   = $query->param('end_date')  || 'no end date';
 
        if ( $query->param('display'))
        {
              # Display referers
           if ( $query->param('display') eq 'ref' )
           {
           display_referrers($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date);
           }
              ##############################  Advanced Counter runmodes. ####################################
              # display countries top 5.
           elsif ( $query->param('display') eq 'country' )
           {
           advanced_counter::display_country($script_name, $stats_file, $sitename, $date, $start_date, $end_date, 'topfive');
           }  
              # display countries summary
           elsif ( $query->param('display') eq 'country_detail' )
           {
           advanced_counter::display_country($script_name, $stats_file, $sitename, $date, $start_date, $end_date, 'moredetail');
           } 
              ################################################################################################
              # display search engines top 5.
           elsif ( $query->param('display') eq 'searchengine' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'topfive');
           }            
              # display countries Google summary.
           elsif ( $query->param('display') eq 'google' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'google');
           }  
              # display countries Yahoo summary.
           elsif ( $query->param('display') eq 'yahoo' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'yahoo');
           } 
              # display countries AltaVista summary.
           elsif ( $query->param('display') eq 'altav' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'altav');
           } 
              # display countries MSN summary.
           elsif ( $query->param('display') eq 'msn' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'msn');
           } 
              # display countries AOL summary.
           elsif ( $query->param('display') eq 'aol' )
           {
           advanced_counter::display_search_summary($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'aol');
           } 
              ################################################################################################
              # Rollover the periodic count files manually.
           elsif ( $query->param('display') eq 'rollover' )
           {
           advanced_counter::rollover($script_name, $stats_file, $sitename, $date, $total_counter_file, $archives_dir, $demo, $page_count_summary_file,
                                      $voting, $age_diff_days, $days_till_archiving,  $overall_count);
           } 
              ################################################################################################
              # Display page hits summaries           

           elsif ( $query->param('display') eq 'pagesummary' )
           {
           advanced_counter::pagesummary($script_name, $page_count_summary_file, $sitename, $date, $start_date, $end_date ,'topfive');
           } 
           elsif ( $query->param('display') eq 'pages_hit_detail' )
           {
           advanced_counter::pagesummary($script_name, $page_count_summary_file, $sitename, $date, $start_date, $end_date ,'pages_hit_detail');
           } 
              # display Daily hit summary.
           elsif ( $query->param('display') eq 'daybyday' )
           {
           advanced_counter::display_daily_hit_summary($script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'topfive');
           }            
           elsif ( $query->param('display') eq 'dayhit_detail' )
           {
           advanced_counter::display_daily_hit_summary($script_name, $stats_file, $sitename, $date, $start_date, $end_date ,'dayhit_detail');
           }  



           else
           {
           &display_stats($total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count);
           }            
        }
        else{
            &display_stats($total_counter_file, $stats_file, $sitename, $date, $voting, $age_diff_days, $days_till_archiving, $script_name, $overall_count);
            }
 }

#############################
sub increment_count
 {
 my ($query, $date, $timestamp, $is_javascript) = @_;
 my $ip_address    =  $ENV{'REMOTE_ADDR'};
     chomp $ip_address;
 my $http_host     =  $ENV{'HTTP_HOST'};
 my $browser       =  $ENV{'HTTP_USER_AGENT'};
 my $request       =  $ENV{'REQUEST_METHOD'};
 my $ref_test      =  $query->param('ref');
 
 # Make sure that the browser user agent env variable doesn't contain pipes.
 $browser =~ s/\|/\&verbar\;/g;

my ($referer, $screen_res);
# If the counter was called with javascript, then collect the referrer.
if ($is_javascript eq 'js')
{
         if ($ref_test)
            {
            $referer = $ref_test;  
            }
         else
            {
            $referer = 'No referer or unundetectable';
            }
}
# If the counter was called without javascript, then use HTTP_REFFERER.
else
{
$referer = $ENV{'HTTP_REFERER'} || 'No referer or unundetectable';
}
#Make sure all html entities that could be in referer are encoded safely.
# Leave this off or it will break any strings containing single inverted commas.
# It's run though before printing anyway so no biggie.
 #require './library/Entities.pl';
 #$referer = Entities::encode($referer);
 $referer =~ s/\|/%7C/g;	
 
if ($query->param('res'))
    {
    $screen_res = $query->param('res');  
    }
else{
    $screen_res = 'nonJS';
    }

if ((($browser =~ m|Googlebot|i) || ($browser =~ m|AltaVista\sIntranet|i) 
                                 || ($browser =~ m|Scooter|i) 
                                 || ($browser =~ m|Slurp|i) 
                                 || ($browser =~ m|Gulliver|i) 
                                 || ($browser =~ m|InfoSeek\sSidewinder|i)
                                 || ($browser =~ m|Ultraseek|i) 
                                 || ($browser =~ m|ia_archiver|i) 
                                 || ($browser =~ m|ArchitextSpider|i) 
                                 || ($browser =~ m|WebCrawler|i)
                                 || ($browser =~ m|msnbot|i)) && ($screen_res eq 'nonJS'))
{
$screen_res = 'nonJS_BOT';
}
# Get all the config data again, its simplier then passing it all to this sub and we need most of it anyway.
# We'll just assign those we don't want to undef, since the config sub does no processing as such, it should
# be nearly as fast as passing the data to the sub anyway.
my (undef, undef, undef, $output_image_path, undef, undef, $stats_file, $total_counter_file, $overall_count, $ip_ignore, 
    $used_ips_dir, $script_name, $ip_age, undef, undef, undef, undef, $tmp_dir) = counter_config::config();
    
my $match   = 0;
my $ipmatch = 0;
       # We store each IP address in a filename that is inserted into 
       # a specific directory. that way we can test the files age to determine
       # how old a specific IP is.
my @IP_files = get_ip_files_list($used_ips_dir);
       foreach my $filename (@IP_files)
              {
              my $file_name = $used_ips_dir.'/'.$filename;
              if (-M $file_name > $ip_age)
                 {
                chomp $filename;
                unless (-f $file_name){shift @IP_files; next;}
                 # Make sure the files are the ones we want to delete.
				 # Thanks to Philb for spotting this one.
                 if ($filename =~ /^(\d+\.\d+\.\d+\.\d+)(\.txt)$/)
	                 {
					$filename = $1 . $2;
	                 unlink("$used_ips_dir/$filename") or htmlfixit::return_error("can't delete: $used_ips_dir/$filename Reason: $!", 'yes');
	                 shift @IP_files;
					 }
                 # Here the directory and @IP_files should both only
                 # contain filenames that exist and are less then 
                 # the specified age.
                 }
              }

       # Open the count file and get the current counts cos we will
       # need it for most of the coming code.
       # The first field is unique hits, the second is all hits bar 
       # those from ignored IP's and the third is all hits bar nothing.
my ($unique, $total_without_ignored, $allhits, $first_hit_date, 
    $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, 
    $overall_allhits) = get_count($total_counter_file, $overall_count);
    
#test, lets write what get_count fetches when reading.
#my $filename='/home/httpd/www/counter/temp_log.txt';
#  open (LOG, ">>$filename") or htmlfixit::return_error("can't open: $filename Reason: $!", 'yes');
#        flock(LOG,LOCK_EX);
#  print LOG "$unique $total_without_ignored $allhits $first_hit_date $first_hit_timestamp $overall_unique $overall_total_without_ignored $overall_allhits\n";
#  close(LOG);    
    
my $ip;  
my $ignore_certain_ips = 'yes';    
    
if ($ignore_certain_ips eq 'yes')
{
# Open IP To look for a match
open (IP, "$ip_ignore") or htmlfixit::return_error("can't open: $ip_ignore Reason: $!", 'yes');
flock(IP,LOCK_SH) or htmlfixit::return_error("can't lock: $ip_ignore Reason: $!", 'yes');
my @IP_array = <IP>;
close (IP);
   foreach $ip (@IP_array)
   {   
    chomp $ip;
         if($ip eq $ip_address)
           {
           $match += 1;
           }
   } #end of foreach


if ($match > 0){
                # Here we know that a known IP has hit the page.
                # Do we do nothing except display the gif and increment the allhits count.
                &output_image($output_image_path);
                $allhits +=1;
                $overall_allhits += 1;
                &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
                                $first_hit_date, $first_hit_timestamp, $overall_unique,
                                $overall_total_without_ignored,  $overall_allhits);
                                
                }

if ($match == 0)
   {
    # NO match to ignored IP. so now lets increment and collect data.
    # Increment the main counter file.
    $allhits                       += 1;
    $total_without_ignored         += 1;
    # increment the overall counter file.
    $overall_total_without_ignored += 1;
    $overall_allhits               += 1;
    
    # If the directory is totally empty, the foreach won't go anywhere, 
    # so we need allow and test for that.
        my $array_count = scalar(@IP_files);
        if ($array_count == 0)
        {       # There are no stored IP's at this point.
                $unique         +=1;
                $overall_unique +=1;

				# ensure they can't break or method of delimiting data.
                $referer =~ s/\|/\&brvbar\;/;
				
                $referer = 'No referer or unundetectable' unless $referer;
                my $total_collected_data = ($unique . '|' . $date . '|' . $timestamp . '|' . $ip_address . '|' . $screen_res . '|' . $browser . '|' . $referer . "\n");
                &write_stats($stats_file, $total_collected_data); 
                &write_ip_to_file($used_ips_dir, $ip_address);
        }

  if ($array_count >= 1)
  {
            foreach my $ipnum (@IP_files)
            {
            ($ipnum, undef) = split(/\.txt/, $ipnum);
            if ($ipnum eq $ip_address)
                {
                $ipmatch  = 1;
                }

             }
                    if ($ipmatch == 0)
                       {
                       $unique         +=1;
                       $overall_unique += 1;
                       # make sure a pipe used in referrer can't break the file format.
                       $referer =~ s/\|/\&brvbar\;/;
                       # same for newlines.
                       $referer =~ s/\n//g; 
                       $referer =~ s/\r//g;
                       my $total_collected_data = ($unique . '|' . $date . '|' . $timestamp . '|' . $ip_address . '|' . $screen_res . '|' . $browser . '|' . $referer . "\n");
                       &write_ip_to_file($used_ips_dir, $ip_address);
                       &write_stats($stats_file, $total_collected_data);       
                       }          
             
   } # End of: if ($array_count >= 1) 
   
    &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
                    $first_hit_date, $first_hit_timestamp, $overall_unique,
                    $overall_total_without_ignored,  $overall_allhits);   
    &output_image($output_image_path);
   } # if ($match == 0)
 } # End of $ignore_certain_ips eq 'yes'
} # End of if $query->parem('count').


sub display_stats
{
my $total_counter_file = shift;
my $stats_file         = shift;
my $sitename           = shift;
my $date               = shift;
my $voting             = shift;
my $age_diff_days      = shift;
my $days_till_archiving= shift;
my $script_name        = shift;
my $overall_count      = shift;

my $css = htmlfixit::display_css(785);

my ($counts, $overall_counts) = read_counts($total_counter_file, $overall_count);

my @stats = read_stats($stats_file); 

$counts = 'none|none|none' unless ($counts);
$overall_counts = 'none|1|none|none|none' unless ($overall_counts);

my ($unique, $total_without_ignored, $total_hits) = split(/\|/, $counts);
my ($first_hit_date, $first_hit_timestamp, $all_unique, $all_total_without_ignored, $all_total_hits) = split(/\|/, $overall_counts);

my ($hitnumber, $hitdate, $timestamp, $hitip, $hitresolution, $hitbrowser, $hitreferer);
my (@hitdate, @hitip, @hitresolution, @hitbrowser, @hitreferer); 

# Added to base unique by the number of items in the stats file instead of the count number.
$unique = scalar (@stats);

foreach my $hit (@stats)
{
        chomp $hit;
        if ($hit ne '') 
        {
        ($hitnumber, $hitdate, $timestamp, $hitip, $hitresolution, $hitbrowser, undef) = split(/\|/, $hit);
        push (@hitdate, $hitdate);
        push (@hitip, $hitip);
        push (@hitresolution, $hitresolution);
        push (@hitbrowser, $hitbrowser);
        }
        else
        {
        next;
        }
}

# Put the hitnumbers into a hash after splitting off the time.
my %unique_dates;
my $daydate;
# Wednesday, December 1, 2004 at 00:18 AM
foreach my $hitdatetime (@hitdate)
{
(undef, $daydate, undef) = split(/\,/, $hitdatetime);
$unique_dates{"$daydate"} = '';
}
my $number_of_days = scalar(keys(%unique_dates));

my $start_date = shift(@hitdate);
my $end_date   = pop(@hitdate);

my ($ie8, $ie7, $ie6, $ie5, $ie_other, $ns8, $moz, $seamonkey, $Kmeleon, $firefox, $firefox2, $firefox3, $epiphany, $ns4, $ns_other, 
    $op9, $op8, $op7, $op6, $op_other, $safari, $safari_Mac_Intel, $safari_Mac_PPC, $safari_Win, $konq, $galeon, $webtv, $others);
my ($googlebot, $altavista, $inktomi, $northern_light, $infoseek, $excite, $webcrawler, $msn, $ia_archiver);

my ($vista, $w2003, $winXP, $win2000, $winNT, $winME, $win98, $win95, $wince, $win_other, $unix, $mac_OSX, $Mac_Classic, $OS_others);
my ($res560x420, $res640x480, $res800x600, $res1024x768, $res1152x864, $res1152x870, $res1152x900, $res1280x960,
    $res1280x1024, $res1440x900, $res1400x1050, $res1600x1200, $res2048x768, $res2304x864, $res_others, $res720x480, 
    $res720x576, $res832x624, $res960x720, $res1152x768, $res1280x720, $res1280x768, $res1280x800, $res1280x854, $res1280x993, $res1536x960,
    $res1600x1024, $res1600x1280, $res1920x1200, $res2560x1024, $nonJS);

     # Most of these could have been combined into single regex's, but 
     # I figure it will need regular updating so I kept them seperate.
     
# New browsers and Operating systems to add.
#Browsers:
#iCab
#SpaceBison (Proxomitron proxy)
#Chimera
#Camino

#Operating sys:
#SunOS
#IRIX
#OS/2
#FreeBSD
#SCO_SV
#OpenBSD
     
foreach my $browse (@hitbrowser)
{
$ie8         += 1 if (($browse =~ m|MSIE 8\.|) && ($browse !~ m|Opera|i));
$ie7         += 1 if (($browse =~ m|MSIE 7\.|) && ($browse !~ m|Opera|i));
$ie6         += 1 if (($browse =~ m|MSIE 6\.|) && ($browse !~ m|Opera|i));
$ie5         += 1 if (($browse =~ m|MSIE 5\.|) && ($browse !~ m|Opera|i));
$ie_other    += 1 if (($browse =~ m|MSIE|) && ($browse !~ m|MSIE 5\.|) 
                                           && ($browse !~ m|MSIE 6\.|) 
                                           && ($browse !~ m|MSIE 7\.|) 
										   && ($browse !~ m|MSIE 8\.|)
                                           && ($browse !~ m|Opera|));

$ns8         += 1 if (($browse =~ m|Netscape\/8\.|));
$moz         += 1 if (($browse =~ m|Mozilla\/5\.|) && ($browse =~ m|Gecko|i) 
                                                   && ($browse !~ m|Safari|i) 
                                                   && ($browse !~ m|Galeon|i) 
                                                   && ($browse !~ m|firefox|i) 
												   && ($browse !~ m|firebird|i) 
                                                   && ($browse !~ m|SeaMonkey|i)
												   && ($browse !~ m|Firefox|i)
												   && ($browse !~ m|K-Meleon|i)
                                                   && ($browse !~ m|Konqueror|i));
$seamonkey	+= 1 if (($browse =~ m|SeaMonkey|i));											   
$Kmeleon	+= 1 if (($browse =~ m|K-Meleon|i));													   
$firefox    += 1 if ((($browse =~ m|Firebird|i)) || (($browse =~ m|Firefox|i))
												&& ($browse !~ m|Firefox\/2\.|i)); 
$firefox2    += 1 if (($browse =~ m|Firefox\/2\.|)); 
$firefox3    += 1 if (($browse =~ m|Firefox\/3\.|));
$epiphany    += 1 if (($browse =~ m|Epiphany|i));

$ns4         += 1 if (($browse =~ m|Mozilla\/4\.7|));
# Don't know enough about netscape 4 and lower to check for it yet.
$op9         += 1 if (($browse =~ m|Opera 9\.|));
$op8         += 1 if (($browse =~ m|Opera 8\.|));
$op7         += 1 if (($browse =~ m|Opera 7\.|));
$op6         += 1 if (($browse =~ m|Opera 6\.|));
$op_other    += 1 if (($browse =~ m|Opera |) && ($browse !~ m|Opera 9\.|)
                                             && ($browse !~ m|Opera 8\.|)
                                             && ($browse !~ m|Opera 7\.|)
                                             && ($browse !~ m|Opera 6\.|));                                          
                                            
$safari   			   	+= 1 if (($browse =~ m|Safari|));

$safari_Mac_Intel		+= 1 if ((($browse =~ m|Safari|i)) && (($browse =~ m|Intel|i))); 
$safari_Mac_PPC			+= 1 if ((($browse =~ m|Safari|i)) && (($browse =~ m|PPC|i))); 
$safari_Win				+= 1 if ((($browse =~ m|Safari|i)) && (($browse =~ m|Windows|i))); 

$konq        += 1 if (($browse =~ m|Konqueror|));
$galeon      += 1 if (($browse =~ m|Galeon|));
$webtv       += 1 if (($browse =~ m|WebTV|));
my $known_bots = 0;
#Spiders. $Resolution
$googlebot  	 += 1 if (($browse =~ m|Googlebot|i));
$altavista       += 1 if (($browse =~ m|AltaVista\sIntranet|i) || ($browse =~ m|Scooter|i));
$inktomi         += 1 if (($browse =~ m|Slurp|i));
$northern_light  += 1 if (($browse =~ m|Gulliver|i));
$infoseek        += 1 if (($browse =~ m|InfoSeek\sSidewinder|i) || ($browse =~ m|Ultraseek|i));
$excite          += 1 if (($browse =~ m|ArchitextSpider|i));
$webcrawler      += 1 if (($browse =~ m|WebCrawler|i));
$msn             += 1 if (($browse =~ m|msnbot|i));
$ia_archiver     += 1 if (($browse =~ m|ia_archiver|i));


$others = 0; # I don't yet have enough info to finish this yet.

$vista       += 1 if (($browse =~ m|Windows NT 6\.0|));
$w2003       += 1 if (($browse =~ m|Windows NT 5\.2|));
$winXP       += 1 if (($browse =~ m|Windows NT 5\.1|));
$win2000     += 1 if (($browse =~ m|Windows NT 5\.0|) || ($browse =~ m|Windows NT 5\.01|));
$winNT       += 1 if (($browse =~ m|Windows NT|) && ($browse !~ m|Windows NT 5|) && ($browse !~ m|Windows NT 6|));

$winME       += 1 if (($browse =~ m|Windows ME|));
$win98       += 1 if (($browse =~ m|Windows 98|) || ($browse =~ m|Win98|)) && ($browse !~ m|Win 9x|);
$wince       += 1 if (($browse =~ m|Windows CE|));
$win95       += 1 if (($browse =~ m|Win95|) || ($browse =~ m|Win 9x|) && ($browse !~ m|Windows 9\.|) );
$win_other   += 1 if (($browse =~ m|Windows|) && ($browse !~ m|Windows NT|) 
                                              && ($browse !~ m|Windows ME|) 
                                              && ($browse !~ m|Windows 98|) 
                                              && ($browse !~ m|Win9\..|) 
                                              && ($browse !~ m|Win 9x|) 
                                              && ($browse !~ m|Windows 2000|));
                                              
$unix        += 1 if (($browse =~ m|Unix|i) || ($browse =~ m|Linux|i) || ($browse =~ m|BSD|i) || ($browse =~ m|SunOS|i));
$mac_OSX     += 1 if (($browse =~ m|Mac OS X|));
$Mac_Classic += 1 if (($browse =~ m|Mac_PowerPC|) || ($browse =~ m|APPLE|));
$OS_others   += 1 if (($browse !~ m|Mac_PowerPC|) 
              && ($browse !~ m|APPLE|)   && ($browse !~ m|Mac OS X|) 
              && ($browse !~ m|Linux|i)   && ($browse !~ m|Unix|i) && ($browse !~ m|BSD|i)
              && ($browse !~ m|Windows|) && ($browse !~ m|Win9\.|) && ($browse !~ m|SunOS|i) && ($browse !~ m|Macintosh|i) && ($browse !~ m|Win 9\.|));
              

# Don't know enough for other.
} #end of foreach.
$ie8      = 'none' if (! $ie8);
$ie7      = 'none' if (! $ie7);
$ie6      = 'none' if (! $ie6);
$ie5      = 'none' if (! $ie5);
$ie_other = 'none' if (! $ie_other);
$ns8      = 'none' if (! $ns8);
$moz      = 'none' if (! $moz);
$seamonkey = 'none' if (! $seamonkey);
$Kmeleon = 'none' if (! $Kmeleon);
$firefox = 'none' if (! $firefox);
$firefox2 = 'none' if (! $firefox2);
$firefox3 = 'none' if (! $firefox3);
$epiphany = 'none' if (! $epiphany);
$ns4      = 'none' if (! $ns4);
$ns_other = 'none' if (! $ns_other);
$op9      = 'none' if (! $op9);
$op8      = 'none' if (! $op8);
$op7      = 'none' if (! $op7);
$op6      = 'none' if (! $op6);
$op_other = 'none' if (! $op_other);
$safari   = 'none' if (! $safari);
$safari_Mac_Intel 	 = 'none' if (! $safari_Mac_Intel);
$safari_Mac_PPC 	 = 'none' if (! $safari_Mac_PPC);
$safari_Win			 = 'none' if (! $safari_Win);
$konq     = 'none' if (! $konq);
$galeon   = 'none' if (! $galeon);
$webtv    = 'none' if (! $webtv);

# use the string 0 rather than the value, so perl doesn't undef it.
# Perl will turn it back to numeric when I add the values up later.
# We set them to 0 here instead of none like the others so we can get a bot total.
$googlebot        = '0' if (! $googlebot);
$altavista        = '0' if (! $altavista);
$inktomi          = '0' if (! $inktomi);
$northern_light   = '0' if (! $northern_light);
$infoseek         = '0' if (! $infoseek);
$excite           = '0' if (! $excite);
$webcrawler       = '0' if (! $webcrawler);
$msn              = '0' if (! $msn);
$ia_archiver      = '0' if (! $ia_archiver);

$others   = 'none' if (! $others);
$vista    = 'none' if (! $vista);
$w2003    = 'none' if (! $w2003);
$winXP    = 'none' if (! $winXP);
$win2000  = 'none' if (! $win2000);
$winNT    = 'none' if (! $winNT);
$winME    = 'none' if (! $winME);
$win98    = 'none' if (! $win98);
$wince    = 'none' if (! $wince);
$win95    = 'none' if (! $win95);
$win_other   = 'none' if (! $win_other);
$unix        = 'none' if (! $unix); 
$mac_OSX     = 'none' if (! $mac_OSX);
$Mac_Classic = 'none' if (! $Mac_Classic);
$OS_others   = 'none' if (! $OS_others);

# update, make win98 and ME one value because they use much the same string.
if ($win98 ne 'none'){
$win98 = ($win98 + $winME) if $winME ne 'none';
}


# ADDED 15 new screen resolutions for advanced stats counter.
foreach my $Resolution (@hitresolution)
{
if  ($Resolution eq '560x420')
    {$res560x420 +=1;}
elsif ($Resolution eq '640x480')
   {$res640x480 +=1;}
elsif ($Resolution eq '720x480')
   {$res720x480 +=1;}   
elsif ($Resolution eq '720x576')
   {$res720x576 +=1;}   
elsif ($Resolution eq '800x600')
   {$res800x600 +=1;}
elsif ($Resolution eq '832x624')
  {$res832x624 +=1;}  
elsif ($Resolution eq '960x720')
  {$res960x720 +=1;}  
elsif ($Resolution eq '1024x768')
   {$res1024x768 +=1;}
elsif ($Resolution eq '1152x768')
   {$res1152x768 +=1;}
elsif ($Resolution eq '1152x864')
   {$res1152x864 +=1;}
elsif ($Resolution eq '1152x870')
   {$res1152x870 +=1;}
elsif ($Resolution eq '1152x900')
   {$res1152x900 +=1;}
elsif ($Resolution eq '1280x720')
   {$res1280x720 +=1;}
elsif ($Resolution eq '1280x768')
   {$res1280x768 +=1;}   
elsif ($Resolution eq '1280x800')
   {$res1280x800 +=1;}      
elsif ($Resolution eq '1280x854')
   {$res1280x854 +=1;}      
elsif ($Resolution eq '1280x960')
   {$res1280x960 +=1;}
elsif ($Resolution eq '1280x993')
   {$res1280x993 +=1;}
elsif ($Resolution eq '1280x1024')
   {$res1280x1024 +=1;}
elsif ($Resolution eq '1440x900')
   {$res1440x900 +=1;}
elsif ($Resolution eq '1400x1050')
   {$res1400x1050 +=1;}
elsif ($Resolution eq '1536x960')
   {$res1536x960 +=1;}
elsif ($Resolution eq '1600x1024')
   {$res1600x1024 +=1;}
elsif ($Resolution eq '1600x1200')
   {$res1600x1200 +=1;}
elsif ($Resolution eq '1600x1280')
   {$res11600x1280 +=1;}
elsif ($Resolution eq '1920x1200')
   {$res1920x1200 +=1;}
elsif ($Resolution eq '2048x768')
   {$res2048x768 +=1;}
elsif ($Resolution eq '2304x864')
   {$res2304x864 +=1;}
elsif ($Resolution eq '2560x1024')
   {$res2560x1024 +=1;}   
elsif (($Resolution eq 'nonJS') or ($Resolution eq 'nonJS_BOT'))
   {$nonJS +=1;}     
else
{$res_others += 1;}
}
my $bottotal = ($googlebot + $altavista + $inktomi + $northern_light + $infoseek + $excite + $webcrawler + $msn + $ia_archiver);

$nonJS = 0 unless $nonJS;
unless ($nonJS < 1)
{
$nonJS = ($nonJS - $bottotal);
}
# bots.
$googlebot        = 'none' if (! $googlebot);
$altavista        = 'none' if (! $altavista);
$inktomi          = 'none' if (! $inktomi);
$northern_light   = 'none' if (! $northern_light);
$infoseek         = 'none' if (! $infoseek);
$excite           = 'none' if (! $excite);
$webcrawler       = 'none' if (! $webcrawler);
$msn              = 'none' if (! $msn);
$ia_archiver      = 'none' if (! $ia_archiver);

$res560x420    = 'none' if (! $res560x420);
$res640x480    = 'none' if (! $res640x480);
$res720x480    = 'none' if (! $res720x480);
$res720x576    = 'none' if (! $res720x576);
$res800x600    = 'none' if (! $res800x600);
$res832x624    = 'none' if (! $res832x624);
$res960x720    = 'none' if (! $res960x720);
$res1024x768   = 'none' if (! $res1024x768);
$res1152x768   = 'none' if (! $res1152x768);
$res1152x864   = 'none' if (! $res1152x864);
$res1152x870   = 'none' if (! $res1152x870);
$res1152x900   = 'none' if (! $res1152x900);
$res1280x720   = 'none' if (! $res1280x720);
$res1280x768   = 'none' if (! $res1280x768);
$res1280x800   = 'none' if (! $res1280x800);
$res1280x854   = 'none' if (! $res1280x854);
$res1280x993   = 'none' if (! $res1280x993);
$res1280x960   = 'none' if (! $res1280x960);
$res1280x1024  = 'none' if (! $res1280x1024);
$res1400x1050  = 'none' if (! $res1400x1050);
$res1440x900   = 'none' if (! $res1440x900);
$res1536x960   = 'none' if (! $res1536x960);
$res1600x1024  = 'none' if (! $res1600x1024);
$res1600x1200  = 'none' if (! $res1600x1200);
$res1600x1280  = 'none' if (! $res1600x1280);
$res1920x1200  = 'none' if (! $res1920x1200);
$res2048x768   = 'none' if (! $res2048x768);
$res2304x864   = 'none' if (! $res2304x864);
$res2560x1024  = 'none' if (! $res2560x1024);
$nonJS         = 'none' if (! $nonJS);
$res_others    = 'none' if (! $res_others);

# Divide the numbe of unique hits by the number of days since the first hit
#, but first make sure the age is not 0 as its bad to divide by 0.
# Average hits calculations should be based on hours,(floating point decimal)
# Instead of days, because days will roll over to the next day when its really only 1 day and 1 second.
# by calculating on hours (or seconds, we will have a much more accurate average.

my $unique_average;
my $adjusted = 1;

$age_diff_days = $number_of_days;
$age_diff_days = 1 unless $age_diff_days;

if ($age_diff_days > 0)
{
        if (($unique ne 'none') && ($unique > 0))
        {
        $unique_average = ($unique / $age_diff_days);
        $unique_average = sprintf("%.2f", $unique_average);
        }
        else {$unique_average = '0.00';}
}
else
{
$unique_average = $unique;
$unique_average = sprintf("%.2f", $unique_average) if $unique_average ne 'none';
}

$voting = 0;
my $vote_output;

if ($voting == 1)
{$vote_output = htmlfixit::voting('\'Stats Counter\'', 'http://htmlfixit.com/vote.php'); }
else{$vote_output = '&nbsp;';}

# This is the main statistical dislay page.                                                 
print "Content-type: text/html\n\n";

# Probably not necessary, but just in case, lets give everything a value 
# if it doens't already have one to stop Perl from issuing warnings.
# about using variables that have not been defined.

$first_hit_date                 = 'no hits yet' unless $first_hit_date;
$all_unique                     = 0             unless $all_unique; 
$all_total_without_ignored      = 0             unless $all_total_without_ignored; 
$all_total_hits                 = 0             unless $all_total_hits;
$unique                         = 0             unless $unique;
$total_without_ignored          = 0             unless $total_without_ignored;
$total_hits                     = 0             unless $total_hits;
$unique_average                 = 0             unless $unique_average;
$start_date                     = $date         unless $start_date;
$end_date                       = $date         unless $end_date;

my $admin_header = output_admin_header($script_name, $sitename, $date, $start_date, $end_date);

#########################################################################
my $stats_summary = 'no';
my $os_stats      = '/path/to/your/files/os_stats.txt';
my $browser_stats = '/path/to/your/files/browser_stats.txt'; 
my $res_stats     = '/path/to/your/files/res_stats.txt'; 

# Work out what day it is.
my $month_day;
(undef, $month_day, undef) = split(/\, /, $date);
my $day;
(undef, $day) = split(/ /, $month_day);

if ($unique)
{
if ($day >= 2)
{
        if ($stats_summary eq 'yes')
                {
                # write the OS stats summary file.
                open (OSSTATS, ">$os_stats") or htmlfixit::return_error("Can't open $os_stats Reason: $!", 'yes');
                flock(OSSTATS,LOCK_EX) or htmlfixit::return_error("Can't lock $os_stats Reason: $!", 'yes');
                print OSSTATS 'Windows Vista:'.$vista.'|Windows 2003:'.$w2003.'|Windows XP:'.$winXP.'|Windows 2000:'.$win2000.'|Windows NT4:'.$winNT.'|Windows 98/ME:'.$win98.'|Windows 95:'.$win95.'|Linux/UNIX/BSD:'.$unix.'|Mac OSX:'.$mac_OSX.'|Mac Classic:'.$Mac_Classic.'|Misc:'.$OS_others;
                close (OSSTATS);

                # write the browser stats summary file.
                open (BROWSESTATS, ">$browser_stats") or htmlfixit::return_error("Can't open $browser_stats Reason: $!", 'yes');
                flock(BROWSESTATS,LOCK_EX) or htmlfixit::return_error("Can't lock $browser_stats Reason: $!", 'yes');
				print BROWSESTATS 'IE 8:'.$ie8.'|IE 7:'.$ie7.'|IE 6:'.$ie6.'|IE 5:'.$ie5.'|IE other:'.$ie_other.'|Netscape 8.x:'.$ns8.'|NS 6+/Mozilla:'.$moz.'|Moz Seamonkey:'.$seamonkey.'|K-meleon:'.$Kmeleon.'|Moz Firefox 0.x/1.x:'.$firefox.'|Moz Firefox 2.x:'.$firefox2.'|Moz Firefox 3.x:'.$firefox3.'|Epiphany:'.$epiphany.'|Netscape 4.x:'.$ns4.'|Opera 9.x:'.$op9.'|Opera 8.x:'.$op8.'|Opera 7.x:'.$op7.'|Opera 6.x:'.$op6.'|Opera other:'.$op_other.'|Safari Mac/Intel:'.$safari_Mac_Intel.'|Safari Mac/PPC:'.$safari_Mac_PPC.'|Safari Windows:'.$safari_Win.'|Konqueror:'.$konq.'|Galeon:'.$galeon.'|WebTV:'.$webtv;
                close (BROWSESTATS);        

                # write the screen resolution summary stats.
                open (RESSTATS, ">$res_stats") or htmlfixit::return_error("Can't open $res_stats Reason: $!", 'yes');
                flock(RESSTATS,LOCK_EX) or htmlfixit::return_error("Can't lock $res_stats Reason: $!", 'yes');
                print RESSTATS '640 x 480:'.$res640x480.'|800 x 600:'.$res800x600.'|1024 x 768:'.$res1024x768.'|1152 x 864:'.$res1152x864.'|1280 x 800:'.$res1280x800.'|1280 x 854:'.$res1280x854.'|1280 x 1024:'.$res1280x1024.'|1400 x 1050:'.$res1400x1050.'|1600 x 1200:'.$res1600x1200.'|1920 x 1200:'.$res1920x1200.'|2560 x 1024:'.$res2560x1024;
                close (RESSTATS);        
                }
}
}
##########################################################################

print <<ENDOFSTATS;
$admin_header
$vote_output
<br />

<div align='center' class='content'>
<br />

<div class='cont'>
<table border='0' align='center'>
   
    <tr>
      <td colspan='2' align='center'><strong>Overall Hit count summary since:<br /> $first_hit_date.</strong><br /><hr noshade='noshade' /></td>
   </tr>  
    <tr>   
      <td align= 'left' title="Unique visitors only, multiple page views don't get counted more then once">Total unique hits:</td><td align= 'left'>$all_unique</td>
   </tr>   
    <tr>   
       <td align= 'left' title='non unique hits, but without ignored IPs'>All hits (without ignored IPs):</td><td align= 'left'>$all_total_without_ignored</td>
   </tr>
    <tr>   
       <td align= 'left' title='All hits including non unique and ignored IPs'>All hits (including ignored IPs):</td><td align= 'left'>$all_total_hits</td>
   </tr> 
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>
    <tr>
      <td colspan='2' align='center'><strong>Total Hit count summary since last rollover on:<br /> $start_date.</strong><br /><hr noshade='noshade' /></td>
   </tr>     
    <tr>
      <td align= 'left' title='Unique only hits for the current period.'>Unique hits for this period:</td><td align= 'left'>$unique</td>
   </tr>
   <tr>
      <td align= 'left' title='None unique hits, but no ignored IPs for the current period.'>Hits without counting ignored addresses :</td><td align= 'left'>$total_without_ignored</td>
   </tr>
   <tr>
      <td align= 'left' title='All hits, non unique and ignored for the current period.'>All hits, including ignored addresses and non unique hits:</td><td align= 'left'>$total_hits</td>
   </tr>
   <tr>
      <td align= 'left' title='Average number of hits per day based on the current period.'>Average unique hits per day:</td><td align= 'left'>$unique_average <br />over $age_diff_days day(s)</td>
   </tr>   
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='browse'>Browser statistics for the last $unique hits.</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 8.x:</td><td align= 'left'>$ie8</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 7.x:</td><td align= 'left'>$ie7</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 6.x:</td><td align= 'left'>$ie6</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer 5.x:</td><td align= 'left'>$ie5</td>
   </tr>
   <tr>
      <td align= 'left'>Internet Explorer other:</td><td align= 'left'>$ie_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
   <tr>
      <td align= 'left'>Mozilla Firefox 3.x (GECKO):</td><td align= 'left'>$firefox3</td>
   </tr>   
 <tr>
      <td align= 'left'>Mozilla Firefox 2.x (GECKO):</td><td align= 'left'>$firefox2</td>
   </tr>  
   <tr>
      <td align= 'left'>Mozilla Firefox 0.x/1.x (GECKO):</td><td align= 'left'>$firefox</td>
   </tr>  
    <tr>
      <td align= 'left'>Mozilla Seamonkey (GECKO) :</td><td align= 'left'>$seamonkey</td>
   </tr>  
  <tr>
        <td align= 'left'>Netscape 8.x (IE/GECKO) :</td><td align= 'left'>$ns8</td>
   </tr>
   <tr>
      <td align= 'left'>Netscape 6+ / Mozilla 1+ (GECKO) :</td><td align= 'left'>$moz</td>
   </tr>
   <tr>
      <td align= 'left'>K-meleon (GECKO) :</td><td align= 'left'>$Kmeleon</td>
   </tr>
   <tr>
      <td align= 'left'>Epiphany (GECKO):</td><td align= 'left'>$epiphany</td>
   </tr> 
  <tr>
      <td align= 'left'>Galeon (GECKO):</td><td align= 'left'>$galeon</td>
  </tr>   
   
   <tr>
      <td align= 'left'>Netscape 4.x:</td><td align= 'left'>$ns4</td>
   </tr>
   <tr>
      <td align= 'left'>Netscape other:</td><td align= 'left'>$ns_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
   <tr>
      <td align= 'left'>Opera 9.x:</td><td align= 'left'>$op9</td>
   </tr>   
   <tr>
      <td align= 'left'>Opera 8.x:</td><td align= 'left'>$op8</td>
   </tr>  
   <tr>
      <td align= 'left'>Opera 7.x:</td><td align= 'left'>$op7</td>
   </tr>
   <tr>
      <td align= 'left'>Opera 6.x:</td><td align= 'left'>$op6</td>
   </tr>
   <tr>
      <td align= 'left'>Opera other:</td><td align= 'left'>$op_other</td>
   </tr>
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
  <tr>
      <td colspan='2'><hr noshade='noshade' style='width:50%' /></td>
  </tr>    
   <tr>
      <td colspan='2'><b>Misc browsers.</b></td>
   </tr> 
  <tr>
      <td align= 'left'>Safari Mac/Intel (KHTML):</td><td align= 'left'>$safari_Mac_Intel</td>
  </tr> 
    <tr>
      <td align= 'left'>Safari Mac/PPC  (KHTML):</td><td align= 'left'>$safari_Mac_PPC</td>
  </tr> 
    <tr>
      <td align= 'left'>Safari Windows (KHTML):</td><td align= 'left'>$safari_Win</td>
  </tr> 
  <!-- 
  <tr>
      <td align= 'left'>Safari total (KHTML):</td><td align= 'left'><strong>$safari</strong></td>
  </tr> 
  //-->
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
  </tr>
  <tr>
      <td align= 'left'>Konqueror (KHTML):</td><td align= 'left'>$konq</td>
  </tr>
  <tr>
      <td align= 'left'>WebTV:</td><td align= 'left'>$webtv</td>
  </tr>  
  <tr>
      <td colspan='2'><hr noshade='noshade' style='width:50%' /></td>
  </tr>    


  <tr>
      <td colspan='2'><strong>Search engine spiders (bots).</strong></td>
  </tr> 
  <tr>
        <td align= 'left'>Googlebot:</td><td align= 'left'>$googlebot</td>
  </tr>  
  <tr>
        <td align= 'left'>AltaVista:</td><td align= 'left'>$altavista</td>
  </tr>  
  <tr>
        <td align= 'left'>Inktomi:</td><td align= 'left'>$inktomi</td>
  </tr>  
  <tr>
        <td align= 'left'>Northern Light:</td><td align= 'left'>$northern_light</td>
  </tr>  
  <tr>
        <td align= 'left'>Infoseek:</td><td align= 'left'>$infoseek</td>
  </tr>  
  <tr>
        <td align= 'left'>Excite:</td><td align= 'left'>$excite</td>
  </tr>  
  <tr>
       <td align= 'left'>Webcrawler:</td><td align= 'left'>$webcrawler</td>
 </tr> 
  <tr>
        <td align= 'left'>MSN:</td><td align= 'left'>$msn</td>
  </tr>  
  <tr>
        <td align= 'left'>Alexa:</td><td align= 'left'>$ia_archiver</td>
  </tr>    
   <tr>
      <td colspan='2'><hr noshade='noshade' style='width:50%' /></td>
   </tr>   
  <tr>
      <td colspan='2'><strong>Of the above browsers, number of <br />graphical browsers without JavaScript</strong></td>
  </tr>   
  <tr>
        <td align= 'left'>Non Js Browsers:</td><td align= 'left'>$nonJS</td>
  </tr>    
  <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>    
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='OS'>Operating system stats for the last $unique hits.</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>Windows Vista:</td><td align= 'left'>$vista</td>
   </tr>
   <tr>
      <td align= 'left'>Windows 2003 server:</td><td align= 'left'>$w2003</td>
   </tr>   
   <tr>
      <td align= 'left'>Windows XP:</td><td align= 'left'>$winXP</td>
   </tr>
   <tr>
      <td align= 'left'>Windows 2000:</td><td align= 'left'>$win2000</td>
   </tr>
   <tr>
      <td align= 'left'>Windows NT4:</td><td align= 'left'>$winNT</td>
   </tr>   
     <tr>
      <td align= 'left'>Windows 98/ME:</td><td align= 'left'>$win98</td>
   </tr>
     <tr>
      <td align= 'left'>Windows CE:</td><td align= 'left'>$wince</td>
   </tr>   
    <tr>
      <td align= 'left'>Windows 95:</td><td align= 'left'>$win95</td>
   </tr>   
   <tr>
      <td align= 'left'>Windows other:</td><td align= 'left'>$win_other</td>
   </tr>    
  <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>   
   <tr>
      <td align= 'left'>Linux/Unix/BSD:</td><td align= 'left'>$unix</td>
   </tr>
   <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>   
   <tr>
      <td align= 'left'>Macintosh OSX:</td><td align= 'left'>$mac_OSX</td>
   </tr>  
   <tr>
      <td align= 'left'>Macintosh Classic:</td><td align= 'left'>$Mac_Classic</td>
   </tr>   
   <tr>
      <td align= 'left'><br /></td><td align= 'left'></td>
   </tr>
   <tr>
      <td align= 'left'>Misc:</td><td align= 'left'>$OS_others</td>
   </tr>  
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'> 
<br />
<div class='cont'>

<table border='0' width='60%' align='center'>
   <tr>
      <td align=' left' colspan='2'><strong><br /><a name='res'>Screen resolution stats for the last $unique hits.</a></strong><br /><hr noshade='noshade' /></td>
   </tr>
   <tr>
      <td align= 'left'>560 x 420:</td><td align= 'left'>$res560x420</td>
   </tr>
   <tr>
      <td align= 'left'>640 x 480:</td><td align= 'left'>$res640x480</td>
   </tr>
   <tr>
      <td align= 'left'>720 x 480:</td><td align= 'left'>$res720x480</td>
   </tr>
   <tr>
      <td align= 'left'>720 x 576:</td><td align= 'left'>$res720x576</td>
   </tr>
   <tr>
      <td align= 'left'>800 x 600:</td><td align= 'left'>$res800x600</td>
   </tr>
   <tr>
      <td align= 'left'>832 x 624:</td><td align= 'left'>$res832x624</td>
   </tr>
   <tr>
      <td align= 'left'>960 x 720:</td><td align= 'left'>$res960x720</td>
   </tr>
   <tr>
      <td align= 'left'>1024 x 768:</td><td align= 'left'>$res1024x768</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 768:</td><td align= 'left'>$res1152x768</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 864:</td><td align= 'left'>$res1152x864</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 870:</td><td align= 'left'>$res1152x870</td>
   </tr>  
   <tr>
      <td align= 'left'>1152 x 900:</td><td align= 'left'>$res1152x900</td>
   </tr> 
   <tr>
      <td align= 'left'>1280 x 720:</td><td align= 'left'>$res1280x720</td>
   </tr>  
   <tr>
      <td align= 'left'>1280 x 768:</td><td align= 'left'>$res1280x768</td>
   </tr>  
   <tr>
      <td align= 'left'>1280 x 800:</td><td align= 'left'>$res1280x800</td>
   </tr>  
   <tr>
      <td align= 'left'>1280 x 854:</td><td align= 'left'>$res1280x854</td>
   </tr>  
   <tr>
      <td align= 'left'>1280 x 993:</td><td align= 'left'>$res1280x993</td>
   </tr>  
   <tr>
      <td align= 'left'>1280 x 960:</td><td align= 'left'>$res1280x960</td>
   </tr>   
   <tr>
      <td align= 'left'>1280 x 1024:</td><td align= 'left'>$res1280x1024</td>
   </tr> 
   <tr>
      <td align= 'left'>1440 x 900:</td><td align= 'left'>$res1440x900</td>
   </tr>   
   <tr>
      <td align= 'left'>1400 x 1050:</td><td align= 'left'>$res1400x1050</td>
   </tr>  
   <tr>
      <td align= 'left'>1536 x 960:</td><td align= 'left'>$res1536x960</td>
   </tr>  
   <tr>
      <td align= 'left'>1600 x 1024:</td><td align= 'left'>$res1600x1024</td>
   </tr>  
   <tr>
      <td align= 'left'>1600 x 1280:</td><td align= 'left'>$res1600x1280</td>
   </tr>  
   <tr>
      <td align= 'left'>1600 x 1200:</td><td align= 'left'>$res1600x1200</td>
   </tr>
   <tr>
      <td align= 'left'>1920 x 1200:</td><td align= 'left'>$res1920x1200</td>
   </tr>
   <tr>
      <td align= 'left'>2048 x 768:</td><td align= 'left'>$res2048x768</td>
   </tr>   
   <tr>
      <td align= 'left'>2304 x 864:</td><td align= 'left'>$res2304x864</td>
   </tr>    
   <tr>
      <td align= 'left'>2560 x 1024:</td><td align= 'left'>$res2560x1024</td>
   </tr> 
   <tr>
      <td align= 'left'>Other:</td><td align= 'left'>$res_others</td>
   </tr> 
   <tr>
      <td colspan='2'><hr noshade='noshade' /></td>
   </tr>   
</table>
</div>
<br />
</div>
<br />
</body>
</html>
ENDOFSTATS
}
################################
# Prints the header html for all admin pages.
#
# Usage: output_admin_header('script_name', 'sitename' 'current date', 'stat start date', 'stat end date');
sub output_admin_header
{
my $script_name = shift;
my $sitename    = shift;
my $date        = shift;
my $start_date  = shift;
my $end_date    = shift;
my $css = htmlfixit::display_css(785);
my $version     = '2.00-pro';

# Just as a last minute check,  make sure all the vars have a value set 
# to stop perl complaining if it doesn't.
$script_name = 'stats.pl'           unless $script_name;
$sitename    = 'mydomain.com'       unless $sitename;
$date        = 'date not available' unless $date;
$start_date  = 'date not available' unless $start_date;
$end_date    = 'date not available' unless $end_date;

my $header = <<ENDOFHEADER;
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html><head>
<title>HTMLfixIT.com Statistical page counter for $sitename.</title>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
$css
</head>
<body>
<br />
<div align='center' class='content'> 
<br />
<div class='cont'>
<h1 align='center'><a href='http://HTMLfixIT.com' class='menu' target='_blank'>HTMLfixIT.com</a></h1>

<h3><a name='top'>Statistical counter for "$sitename"</a></h3>
<p align='center'><b>Todays date:&nbsp;&nbsp;</b> $date</p>
<table  align='center' width='70%' cellpadding='0' cellspacing='0'>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
<tr>
  <td><b>The first stat was collected on:</b></td>
  <td>$start_date</td>
</tr>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
<tr>
  <td><b>The last stat was collected on:</b></td>
  <td>$end_date</td>
</tr>
<tr>
  <td>&nbsp;</td>
  <td>&nbsp;</td>
</tr>
</table>
</div>
<br />
</div>
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
<h2 align='center' style='margin-top:5px; margin-bottom:5px;'>Standard statistics menu.</h2>
<p>Move your mouse over the buttons to get a better description of what each does.</p>
<form action='http://htmlfixit.com/advanced.php' method='post' style='margin-top:5px; margin-bottom:5px;'>
<input type='button' value='Browser stats' title='Go to the Browser statistics.' class='buttons' onclick='location.href="$script_name?login=yes#browse"' />&nbsp;
<input type='button' value='Operating Systems' title='Go to the Operating System statistics.' class='buttons' onclick='location.href="$script_name?login=yes#OS"' />&nbsp;
<input type='button' value='Screen Resolutions' title='Go to the Screen Resoluton statistics.' class='buttons' onclick='location.href="$script_name?login=yes#res"' />
<input type='button' value='Refresh count' title='Refresh the hit count.' class='buttons' onclick='location.href="$script_name?login=yes"' />
<input type='button' value='Logout' title='Return to the login screen' class='buttons' onclick='location.href="$script_name?login=yes\&logout=yes"' />
</form>

<br />
<hr width='95%' noshade='noshade' />
<h2 align='center' style='margin-top:0px; margin-bottom:5px;'>Advanced statistics menu.</h2>
<table width='400px' cellpadding='0' cellspacing='0'>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='$script_name#refs' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='ref' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show the list of refering web sites.'  value='Show referrers' class='buttons' />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='pagesummary' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Show the breakdown of hits to all the pages in your site.' value='Pages hit summary' class='buttons' />
</form>
  </td>
</tr>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='searchengine' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='A breakdown of terms used in search engines that lead to your site.' value='Search engine summary' class='buttons' />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='daybyday' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='A day by day breakdown of hits to your site.' value='Day by day counts' class='buttons' />
</form>
  </td>
</tr>
<tr>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:4px; margin-left:0px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='rollover' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='button' title='Set the count back to zero now.' value='Roll over counts now' class='buttons' onclick="javascript:if(confirm('Are you sure you want to reset all the perodic counter files?')){this.form.submit()}else{return false}" />
</form>
  </td>
  <td>
<form style='margin-top:1px; margin-bottom:0px; margin-right:0px; margin-left:4px;' action='$script_name' method='post'>
<input type='hidden' name='login' value='yes' />
<input type='hidden' name='display' value='country' />
<input type='hidden' name='sitename' value='$sitename' />
<input type='hidden' name='start_date' value='$start_date' />
<input type='hidden' name='end_date' value='$end_date' />
<input type='submit' title='Shows what countries your hits are comming from.' value='Countries of hits summary' class='buttons' />
</form>
  </td>
</tr>
<tr>
  <td colspan='2' align='center'>
  </td>
</tr>
</table>
<br />
</div><br />
</div>
<br />
<div class='content' align='center'><br /><div class='cont'>
<iframe  width='500px' height='45px' frameborder='0' src='http://htmlfixit.com/inserts/insert-stats.php?ver=$version'>
</iframe>

</div><br /></div>
ENDOFHEADER

return $header;
}

################################
#
# usage: display_referrers($script_name, $stats_file, $sitename, $date, $start_date, $end_date);

sub display_referrers
{
my ($query, $script_name, $stats_file, $sitename, $date, $start_date, $end_date) = @_;

my $display_number = 500;
# make sure the vars all have values before we try and use them.
$sitename     = 'mydomain.com'       unless $sitename;
$date         = 'date not available' unless $date;

my @stats     = read_stats($stats_file);
my $num_stats = scalar(@stats);
if ($num_stats > 0)
{
(undef, $start_date, undef, undef, undef, undef, undef) = split(/\|/, $stats[0]);
(undef, $end_date, undef, undef, undef, undef, undef) = split(/\|/, $stats[($num_stats -1)]);
}
else 
{
$start_date = htmlfixit::get_date();
$end_date   = $start_date;
}

$start_date   = 'date not available' unless $start_date;
$end_date     = 'date not available' unless $end_date;

my $admin_header = output_admin_header($script_name, $sitename, $date, $start_date, $end_date);


my $hitreferer = 'Not Detected';
my @hitreferer;
foreach my $hit (@stats)
{
        chomp $hit;
        if ($hit ne '')
        {
        (undef, undef, undef, undef, undef, undef, $hitreferer) = split(/\|/, $hit);
        push (@hitreferer, $hitreferer);
        }
        else
        {
        next;
        }
}

##################################################################################
# Code to provide next and previous links to limit display to only $display_number at a time.

# how many items are there overall?
my $num_refs   = scalar(@hitreferer);

my $url_string = '&nbsp;';
my $current    = $query->param('current') || $display_number;

if ($num_refs)
	{
	if ($query->param('current'))
	{
    $current    = $num_refs if $query->param('current') eq 'last';
    $current    = $display_number if $query->param('current') eq 'first'; 
    }
	$current    = $num_refs if $current > $num_refs;
	}
else 
	{
	$current = $display_number;
	}   
   $current    = $display_number if $current < $display_number;

   $current     = $num_refs if $current > $num_refs ;
my $next       = $current + $display_number;
my $previous   = $current - $display_number;
my $last_block;

$script_name = $script_name . '#refs';
$last_entry  = $script_name . '#last';
my $start;

if ($num_refs > $display_number)
{
        if ($current <= $display_number)
        {
        # This means to display the first block.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'ref', 'no', 'no', $next, 'yes');
        }
        elsif ($current >= $num_refs)
        {
        # This means to display the last block.
        $last_block = 'yes';
        my $prev     = int(($num_refs / $display_number)+1);
           $previous = (($prev * $display_number) - $display_number);
        
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'ref', 'yes', $previous, 'no', 'no');
        }
        elsif (($current > $display_number) && ($current < $num_refs))
        {
        # not on first block, not on last.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'ref', 'yes', $previous, $next, 'yes');
        }
        else
        {
        # Dunno what woudl cause this to be triggered, but better to be prepared.
        $url_string  = htmlfixit::next_prev($query, $script_name, $sitename, $start_date, $end_date, 'ref', 'yes', 'no', 'no', 'yes');
        }
        $url_string .= '<br />';

   $start     = ($current - $display_number);
   $start = 0 if $start < 0;
   $last_block = 'no' unless $last_block;
   if ($last_block eq 'yes')
   {
   my $remainder = (int($num_refs) % $display_number);
   $start = ($current - $remainder);
   }
   
   
@hitreferer = @hitreferer[($start..$current)];
}
if ($num_refs)
{
$url_string = $start .' to '. $current .$url_string;
}
###################################################################################


my $ref_number = $start || 1;
   $ref_number = 1 if $ref_number < $display_number;
$ref_number = 1 unless $ref_number > 0;
my $no_refs = '0';
my $referer_table;
my $link_name;
my $odd = "<tr class='odd'>";
my $evn = "<tr class='evn'>";
my $tr_color    = $odd;
if (@hitreferer)
{
require './library/Entities.pl';
        foreach my $refering (@hitreferer)
        {
		$refering = 'No referer or unundetectable' unless $refering;
        chomp $refering if $refering;

                if (($refering eq '') || ($refering eq 'referrer blocked by AdSubtract') || 
                                         ($refering eq 'No referer or unundetectable')   || 
                                         ($refering eq 'Not Your Business!')             || 
                                         ($refering eq 'Hidden-Referrer')                || 
                                         ($refering eq 'blockedReferrer'))
                {
                $no_refs += 1;
                delete $hitreferer{"$refering"};
                next;
                }
				$refering =~ s/ /\%20/g;
	
		$refering = Entities::encode($refering);		
        $refering =~ s/\n//g;				
				
				
				if ($refering =~ m|google|i)
				{
				$refering =~ s/\%20/\+/g;
				$refering =~ s//\+/g;
				$refering =~ s/&amp;/\&/g;
				}					
                $link_name = $refering;
                my $name_length = length $link_name;
                my $shortened1;
                my $shortened2;
                
                if ($name_length > 240)
                {
                $shortened1 = substr($link_name, 0, 240);
                $link_name = $shortened1;
                }                

                if ($name_length > 120)
                {
                $shortened1 = substr($link_name, 0, 120);
                $shortened2 = substr($link_name, 120);
                $link_name = $shortened1 . '<br />' .$shortened2;
                }

        if ($ref_number > 1){ $tr_color = ($ref_number % 2) ? $odd : $evn;}
        $referer_table .= $tr_color.'<td align= \'left\'><span class=\'small\'>'.$ref_number.'.&nbsp;<a href=\'' . $refering . '\' target=\'_blank\'>' . $link_name .'</a></span></td></tr>' . "\n";
        $ref_number += 1;
        }
}
else 
{
        $referer_table .= '<tr><td align= \'left\'><span class=\'small\'>no referers yet.</span></td></tr>' . "\n";
}
print "Content-type: text/html\n\n";

print <<ENDOFREFFERER;
$admin_header
<br />
<div align='center' class='content'>
<br />
<div class='cont'>
   <p align='center'><strong><br /><a name='refs'>Summary of pages that referred visitors to: "$sitename"</a></strong><br /><br />
   Because this display could be very long, it is broken into blocks of $display_number referers at a time.<br /><br />
   <b>$no_refs</b> hits from this block had no referrer information.<br /><br />
   <strong>NOTE:</strong> Some URL's are very long in the display below they have been<br /> truncated to their first 240 characters to prevent display problems.<br /> 
   Clicking on a link however, will open the complete unaltered address.</p>
   $url_string
</div><br />
<table border="0" width="90%" class="cont" cellpadding="3" cellspacing="0">
   $referer_table
    <tr><td style='border:0px solid white;' align= 'center'><a name='last'>&nbsp;<br /></a>$url_string<br />
    <a href='#top'>Top</a>
    </td></tr>  
</table>

<br />
</div>
<br /><br />
<p align='center'>Copyright &copy; 2003-2004 Frank Hauptle <a href='http://htmlfixit.com' target='_blank'>HTMLfixIT.com</a><br /> All rights reserved.</p>
<br />
</body>
</html>
ENDOFREFFERER

}

################################
sub output_image
{
my $output_image_path = shift;
       local $/ = undef;
       open (IMAGE, "$output_image_path") or htmlfixit::return_error("Can't open $output_image_path Reason: $!", 'yes');
       flock(IMAGE,LOCK_SH) or htmlfixit::return_error("Can't lock $output_image_path Reason: $!", 'yes');
       # BINMODE IMAGE;
       my $image = <IMAGE>;
       print "Content-type: image/gif\n\n";
       print $image;
       close (IMAGE);
}
################################
sub write_stats
{
my $stats_file = shift;
my $total_collected_data = shift;

     open (STATS, ">>$stats_file") or htmlfixit::return_error("Can't open $stats_file Reason: $!", 'yes');
     flock(STATS,LOCK_EX) or htmlfixit::return_error("Can't lock $stats_file Reason: $!", 'yes');     
     print STATS "$total_collected_data";
     close (STATS);
} 
################################
# usage: my $first_stat = read__first_stat($stats_file); 
# This is a seperate sub from the one below because its 
# not necessary to use a loop to get just the first line 
# of the file, which is all we need to check the first hits 
# times stamp.
sub read__first_stat
{
my $stats_file = shift;
     open (STATS, "$stats_file") or htmlfixit::return_error("Can't open $stats_file Reason: $!", 'yes');
     flock(STATS,LOCK_EX) or htmlfixit::return_error("Can't lock $stats_file Reason: $!", 'yes');  
     my $first_stat = <STATS>;
     close (STATS);

return $first_stat;     
}

################################
# usage: my (@stats) = read_stats($stats_file); 
sub read_stats
{
my $stats_file = shift;
     open (STATS, "$stats_file") or htmlfixit::return_error("Can't open $stats_file Reason: $!", 'yes');
     flock(STATS,LOCK_EX) or htmlfixit::return_error("Can't lock $stats_file Reason: $!", 'yes');
     my @stats = <STATS>;
     close (STATS);
return (@stats);     
}
################################
# usage: my ($counts, $overall_counts) = read_counts($total_counter_file, $overall_count);
sub read_counts
{
my $total_counter_file = shift;
my $overall_count      = shift; 

     open (COUNT, "$total_counter_file") or htmlfixit::return_error("Can't open $total_counter_file Reason: $!", 'yes');
     flock(COUNT,LOCK_SH) or htmlfixit::return_error("Can't lock $total_counter_file Reason: $!", 'yes');
     my $counts = <COUNT>;
     close(COUNT); 
     
     open (ALLCOUNT, "$overall_count") or htmlfixit::return_error("Can't open $overall_count Reason: $!", 'yes');
     flock(ALLCOUNT,LOCK_SH) or htmlfixit::return_error("Can't lock $overall_count Reason: $!", 'yes');
     my $all_counts = <ALLCOUNT>;
     close(ALLCOUNT);      
     
return ($counts, $all_counts);
}



################################
# usage: &update_counter($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
#                        $first_hit_date, $first_hit_timestamp, $overall_unique,
#                        $overall_total_without_ignored,  $overall_allhits);
sub update_counter
{
#     my ($total_counter_file, $overall_count, $unique, $total_without_ignored, $allhits,
#         $first_hit_date, $first_hit_timestamp, $overall_unique,
#         $overall_total_without_ignored,  $overall_allhits) = @_;
         
my $total_counter_file            = shift;
my $overall_count                 = shift;
my $unique                        = shift;
my $total_without_ignored         = shift;
my $allhits                       = shift;
my $first_hit_date                = shift;
my $first_hit_timestamp           = shift;
my $overall_unique                = shift;
my $overall_total_without_ignored = shift;
my $overall_allhits               = shift;

# We need the correct date and timestamp in case the values don't already exist
# Like they would not in a new install, (empty files).
my $date = htmlfixit::get_date();
my $timestamp = time;

# Make sure all of the variables actually have a value.
$unique                        = 1 unless $unique;
$total_without_ignored         = 1 unless $total_without_ignored;
$allhits                       = 1 unless $allhits;
$first_hit_date                = $date unless $first_hit_date;
$first_hit_timestamp           = $timestamp unless $first_hit_timestamp;
$overall_unique                = 1 unless $overall_unique;
$overall_total_without_ignored = 1 unless $overall_total_without_ignored;
$overall_allhits               = 1 unless $overall_allhits;

# Update the normal count file.
my $string = $unique . '|' . $total_without_ignored . '|' . $allhits;
     open (COUNT, ">$total_counter_file") or htmlfixit::return_error("Can't open $total_counter_file Reason: $!", 'yes');
     flock(COUNT,LOCK_EX)  or htmlfixit::return_error("Can't lock $total_counter_file Reason: $!", 'yes');
     print COUNT $string;
     close(COUNT);
     
# Update the overall count file.     
my $overall_string = $first_hit_date.'|'.$first_hit_timestamp.'|'.$overall_unique.'|'.$overall_total_without_ignored.'|'.$overall_allhits;
     open (COUNT, ">$overall_count") or htmlfixit::return_error("Can't open $overall_count Reason: $!", 'yes');
     flock(COUNT,LOCK_EX)  or htmlfixit::return_error("Can't lock $overall_count Reason: $!", 'yes');
     print COUNT $overall_string;
     close(COUNT);    
}
################################
# usage: my ($unique, $total_without_ignored, $allhits, $first_hit_date, $first_hit_timestamp, $overall_unique, 
#            $overall_total_without_ignored, $overall_allhits ) = get_count($total_counter_file, $overall_count);

sub get_count
{
my ($total_counter_file, $overall_count) = @_;
my ($count, $allcount); 
my $date = htmlfixit::get_date();
my $timestamp = time;

  # Get normal Count.
  open (COUNT, "$total_counter_file") or htmlfixit::return_error("Can't open $total_counter_file Reason: $!", 'yes');
  flock(COUNT,LOCK_SH) or htmlfixit::return_error("Can't lock $total_counter_file Reason: $!", 'yes');
  $count = <COUNT>;
  if (! $count) {$count = '0|0|0';}
   my ($unique, $total_without_ignored, $allhits) = split(/\|/, $count);
  close (COUNT); 
  
  # Get overall Count.
  open (ALLCOUNT, "$overall_count") or htmlfixit::return_error("Can't open $overall_count Reason: $!", 'yes');
  flock(ALLCOUNT,LOCK_SH) or htmlfixit::return_error("Can't lock $overall_count Reason: $!", 'yes');  
  $allcount = <ALLCOUNT>;
   if (! $allcount) {$allcount = $date.'|'.$timestamp.'|0|0|0';}
  my ($first_hit_date, $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, $overall_allhits) = split(/\|/, $allcount);
  close (ALLCOUNT);   

return ($unique, $total_without_ignored, $allhits, $first_hit_date, $first_hit_timestamp, $overall_unique, $overall_total_without_ignored, $overall_allhits);

}

#################################
# usage my @IP_files = get_ip_files_list($used_ips_dir);

sub get_ip_files_list
{
my $used_ips_dir = shift;
opendir (IPFILES, "$used_ips_dir") or htmlfixit::return_error("Can't open directory $used_ips_dir Reason: $!", 'yes');
my @IP_files = grep(/\.[0-9, a-z, A-Z]/,readdir(IPFILES));
closedir (IPFILES);
return @IP_files;
}
#################################
# usage: &write_ip_to_file($used_ips_dir, $ip_address);

sub write_ip_to_file
{
my ($used_ips_dir, $ip_address) = @_;
my $new_filename = $ip_address . '.txt';
   # Make sure the file name is just an IP address.
   $new_filename =~ /^(\d+\.\d+\.\d+\.\d+)\.(\w+)$/;
   $new_filename = $1 .'.' .$2;

open (FILE, ">$used_ips_dir/$new_filename") or htmlfixit::return_error("Can't open $used_ips_dir/$new_filename Reason: $!", 'yes');
flock(FILE,LOCK_EX) or htmlfixit::return_error("Can't lock $used_ips_dir/$new_filename Reason: $!", 'yes');
close (FILE);
}
#################################
1;