#!/usr/bin/perl -Tw

use strict;
use warnings;
use diagnostics;
use CGI;
my $query = new CGI;

my $advanced;
if ($query->param('advanced'))
{
$advanced = 'yes';
}
else 
{
$advanced = 'no';
}

require "./counter_config.pl";

print "Content-type: text/html\n\n";

print '<html><head><title>HTMLfixIT script install tester.</title></head><body>';
print "<h1><a href='http://htmlfixit.com' style='text-decoration:none; color:#c00;'>HTMLfixIT</a> Statistical counter installation tester.</h1>";

# Get all the params from the standard counter config file.
my ($user_name, $pass_word, $sitename, $output_image_path, $days_before_archiving_stats, $archives_dir,
        $stats_file, $total_counter_file, $overall_count, $ip_ignore, $used_ips_dir, $script_name, $ip_age, $domain, $path, 
        $expiration, $cookie_id, $tmp_dir) = counter_config::config();
        
# Start testing that all the relevant files exist and have writable permissions.
####################################################
if (-e $archives_dir)
        {
        # File exists, now check if its writable.
        unless (-w $archives_dir)
                {
                print "$archives_dir (\$archives_dir) exists, but is not writable by the web server user.<br />";
                }
        }
else    {
        print "$archives_dir (\$archives_dir) does not exist.<br />";
        }
####################################################
if (-e $stats_file)
        {
        # File exists, now check if its writable.
        unless (-w $stats_file)
                {
                print "$stats_file (\$stats_file) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$stats_file (\$stats_file) does not exist.<br />";
        }
####################################################
if (-e $total_counter_file)
        {
        # File exists, now check if its writable.
        unless (-w $total_counter_file)
                {
                print "$total_counter_file (\$total_counter_file) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$total_counter_file (\$total_counter_file) does not exist.<br />";
        }

####################################################
if (-e $overall_count)
        {
        # File exists, now check if its writable.
        unless (-w $overall_count)
                {
                print "$overall_count (\$overall_count) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$overall_count (\$overall_count) does not exist.<br />";
        }
####################################################
if (-e $ip_ignore)
        {
        # File exists, now check if its writable.
        unless (-r $ip_ignore)
                {
                print "$ip_ignore (\$ip_ignore) exists, but is not readable by the web server user.<br />";
                }
        }
else
        {
        print "$ip_ignore (\$ip_ignore does not exist.<br />";
        }
####################################################
if (-e $used_ips_dir)
        {
        # File exists, now check if its writable.
        unless (-w $used_ips_dir)
                {
                print "$used_ips_dir (\$used_ips_dir) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$used_ips_dir (\$used_ips_dir) does not exist.<br />";
        }
####################################################
if (-e $tmp_dir)
        {
        # File exists, now check if its writable.
        unless (-w $tmp_dir)
                {
                print "$tmp_dir (\$tmp_dir) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$tmp_dir (\$tmp_dir) does not exist.<br />";
        }
####################################################

############## Completed tests for standard counter. ################
########## Now begin tests if the advx counter param is set. ########
if ($advanced eq 'yes')
{
require "./advanced_counter_config.pl";
my ($library_path, $page_count_summary_file) = advanced_counter_config::adconfig();
print '<br /><br />Now testing advanced counter settings.';
####################################################
if (-e $library_path)
        {
        # File exists, now check if its writable.
        unless (-r $library_path)
                {
                print "$library_path (\$library_path) exists, but is not readable by the web server user.<br />";
                }
        }
else
        {
        print "$library_path (\$library_path) does not exist.<br />";
        }
####################################################
if (-e $page_count_summary_file)
        {
        # File exists, now check if its writable.
        unless (-w $page_count_summary_file)
                {
                print "$page_count_summary_file (\$page_count_summary_file) exists, but is not writable by the web server user.<br />";
                }
        }
else
        {
        print "$page_count_summary_file (\$page_count_summary_file) does not exist.<br />";
        }
####################################################

}

print '<br /><br />Any errors will have been reported above this line. If there is nothing above this line, then the installation is good as far as this script can tell.';
print '<br />If your script is the advanced counter, please append ?advanced=yes to the end of the URL, like so: <br /><br />http://mydomain.com/cgi-bin/fixit-counter/install-tool.pl?advanced=yes';
print '</body></html>';